/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.emftext.language.java.imports;

import org.eclipse.emf.common.util.EList;

import org.emftext.language.java.classifiers.ConcreteClassifier;

import org.emftext.language.java.commons.NamedElement;
import org.emftext.language.java.commons.NamespaceAwareElement;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Import</b></em>'.
 * <!-- end-user-doc -->
 *
 *
 * @see org.emftext.language.java.imports.ImportsPackage#getImport()
 * @model abstract="true"
 * @generated
 */
public interface Import extends NamespaceAwareElement
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Returns the classifier with the given name 
   *  located in the namespace defined by the import.
   *  
   *  @param name the name of the classifier
   *  @return imported classifier (proxy)
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='java.lang.String containerName = getNamespacesAsString ( ) ; \nif ( containerName == null ) { \n\treturn null ; \n} \njava.lang.String fullQualifiedName = containerName + name ; \nreturn getConcreteClassifierProxy ( fullQualifiedName ) ; \n'"
   * @generated
   */
  ConcreteClassifier getImportedClassifier(String name);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Returns a list of imported classifiers assuming the import's namespace
   *  identifies a package.
   *  
   *  @param _this 
   *  @return imported classifier (proxy)
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='java.lang.String containerName = getNamespacesAsString ( ) ; \nif ( containerName == null ) { \n\treturn org.eclipse.emf.common.util.ECollections .emptyEList ( ) ; \n} \nreturn getConcreteClassifierProxies ( containerName , \"*\" ) ; \n'"
   * @generated
   */
  EList<ConcreteClassifier> getImportedClassifiers();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Returns all imported members assuming the import's namespace
   *  identifies a classifier.
   *  
   *  @param _this 
   *  @return list of imported classifiers (proxies)
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.emftext.language.java.classifiers.ConcreteClassifier concreteClassifier = getClassifierAtNamespaces ( ) ; \nif ( concreteClassifier == null || concreteClassifier .eIsProxy ( ) ) { \n\treturn org.eclipse.emf.common.util.ECollections .emptyEList ( ) ; \n} \norg.eclipse.emf.common.util.EList < org.emftext.language.java.commons.NamedElement > result = new org.emftext.language.java.util.UniqueEList < org.emftext.language.java.commons.NamedElement > ( ) ; \nresult .addAll ( concreteClassifier .getAllMembers ( this ) ) ; \nif ( concreteClassifier instanceof org.emftext.language.java.classifiers.Enumeration ) { \n\tresult .addAll ( ( ( org.emftext.language.java.classifiers.Enumeration ) concreteClassifier ) .getConstants ( ) ) ; \n} \nreturn result ; \n'"
   * @generated
   */
  EList<NamedElement> getImportedMembers();

} // Import
