/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.emftext.language.java.references;

import org.eclipse.emf.common.util.EList;

import org.emftext.language.java.arrays.ArraySelector;

import org.emftext.language.java.expressions.PrimaryExpression;

import org.emftext.language.java.generics.TypeArgumentable;

import org.emftext.language.java.types.Type;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.java.references.Reference#getNext <em>Next</em>}</li>
 *   <li>{@link org.emftext.language.java.references.Reference#getArraySelectors <em>Array Selectors</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.java.references.ReferencesPackage#getReference()
 * @model abstract="true"
 * @generated
 */
public interface Reference extends PrimaryExpression, TypeArgumentable
{
  /**
   * Returns the value of the '<em><b>Next</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Next</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Next</em>' containment reference.
   * @see #setNext(Reference)
   * @see org.emftext.language.java.references.ReferencesPackage#getReference_Next()
   * @model containment="true" resolveProxies="true"
   * @generated
   */
  Reference getNext();

  /**
   * Sets the value of the '{@link org.emftext.language.java.references.Reference#getNext <em>Next</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Next</em>' containment reference.
   * @see #getNext()
   * @generated
   */
  void setNext(Reference value);

  /**
   * Returns the value of the '<em><b>Array Selectors</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.java.arrays.ArraySelector}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Array Selectors</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Array Selectors</em>' containment reference list.
   * @see org.emftext.language.java.references.ReferencesPackage#getReference_ArraySelectors()
   * @model containment="true" resolveProxies="true"
   * @generated
   */
  EList<ArraySelector> getArraySelectors();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Determines the <code>Type</code> of the reference. That is,
   *  either the type to which the reference points directly, or the
   *  type of the element to which the reference points.
   *  
   *  @return the determined type
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='if ( this instanceof org.emftext.language.java.literals.Literal ) { \n\treturn ( ( org.emftext.language.java.literals.Literal ) this ) .getType ( ) ; \n} \norg.emftext.language.java.types.Type type = null ; \n//referenced element point to a type\n//element points to this or super\nif ( this instanceof org.emftext.language.java.types.TypedElement ) { \n\torg.emftext.language.java.types.TypeReference typeRef = ( ( org.emftext.language.java.types.TypedElement ) this ) .getTypeReference ( ) ; \n\ttype = typeRef .getBoundTarget ( this ) ; \n} else //element points to the object\'s class object\nif ( this instanceof org.emftext.language.java.references.SelfReference ) { \n\torg.emftext.language.java.types.Type thisClass = null ; \n\tif ( this .getPrevious ( ) != null ) { \n\t\tthisClass = this .getPrevious ( ) .getReferencedType ( ) ; \n\t} else { \n\t\torg.emftext.language.java.classifiers.AnonymousClass anonymousContainer = getContainingAnonymousClass ( ) ; \n\t\tif ( anonymousContainer != null ) { \n\t\t\tthisClass = anonymousContainer ; \n\t\t} else { \n\t\t\tthisClass = getContainingConcreteClassifier ( ) ; \n\t\t} \n\t} \n\t//find super class if \"self\" is \"super\"\nif ( ( ( org.emftext.language.java.references.SelfReference ) this ) .getSelf ( ) instanceof org.emftext.language.java.literals.Super ) { \n\t\tif ( thisClass instanceof org.emftext.language.java.classifiers.Class ) { \n\t\t\treturn ( ( org.emftext.language.java.classifiers.Class ) thisClass ) .getSuperClass ( ) ; \n\t\t} \n\t\tif ( thisClass instanceof org.emftext.language.java.classifiers.AnonymousClass ) { \n\t\t\treturn ( ( org.emftext.language.java.classifiers.AnonymousClass ) thisClass ) .getSuperClassifier ( ) ; \n\t\t} \n\t} \n\treturn thisClass ; \n} else //referenced element points to an element with a type\nif ( this instanceof org.emftext.language.java.references.ReflectiveClassReference ) { \n\treturn getClassClass ( ) ; \n} else //Strings may also appear as reference\nif ( this instanceof org.emftext.language.java.references.ElementReference ) { \n\torg.emftext.language.java.references.ReferenceableElement target = ( org.emftext.language.java.references.ReferenceableElement ) ( ( org.emftext.language.java.references.ElementReference ) this ) .getTarget ( ) ; \n\tif ( target .eIsProxy ( ) ) { \n\t\ttype = null ; \n\t} \n\t//Navigate through AdditionalLocalVariable or Field\nif ( target instanceof org.emftext.language.java.variables.AdditionalLocalVariable ) { \n\t\ttarget = ( org.emftext.language.java.references.ReferenceableElement ) target .eContainer ( ) ; \n\t} \n\tif ( target instanceof org.emftext.language.java.members.AdditionalField ) { \n\t\ttarget = ( org.emftext.language.java.references.ReferenceableElement ) target .eContainer ( ) ; \n\t} \n\tif ( target instanceof org.emftext.language.java.types.TypedElement ) { \n\t\torg.emftext.language.java.types.TypeReference typeRef = ( ( org.emftext.language.java.types.TypedElement ) target ) .getTypeReference ( ) ; \n\t\tif ( typeRef != null ) { \n\t\t\ttype = typeRef .getBoundTarget ( this ) ; \n\t\t} \n\t} else /*e.g. Annotation\052/if ( target instanceof org.emftext.language.java.types.Type ) { \n\t\treturn ( org.emftext.language.java.types.Type ) target ; \n\t} else if ( target instanceof org.emftext.language.java.members.EnumConstant ) { \n\t\ttype = ( org.emftext.language.java.classifiers.Enumeration ) target .eContainer ( ) ; \n\t} \n} else if ( this instanceof org.emftext.language.java.references.StringReference ) { \n\treturn getStringClass ( ) ; \n} else if ( this instanceof org.emftext.language.java.expressions.NestedExpression ) { \n\ttype = ( ( org.emftext.language.java.expressions.NestedExpression ) this ) .getExpression ( ) .getType ( ) ; \n} else if ( this instanceof org.emftext.language.java.references.PrimitiveTypeReference ) { \n\ttype = ( ( org.emftext.language.java.references.PrimitiveTypeReference ) this ) .getPrimitiveType ( ) ; \n} else { \n\tassert ( false ) ; \n} \nreturn type ; \n'"
   * @generated
   */
  Type getReferencedType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='if ( eContainer() instanceof org.emftext.language.java.references.Reference ) { \n\t\t\t Reference container = (Reference) eContainer( ) ; \n\t\t\t  if (this.equals(container.getNext())) {\n\t\t\t\t return container;\n\t\t\t }\n}\nreturn null;'"
   * @generated
   */
  Reference getPrevious();

} // Reference
