/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.emftext.language.java.types;

import org.emftext.language.java.commons.Commentable;

import org.emftext.language.java.references.Reference;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Type Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 *
 * @see org.emftext.language.java.types.TypesPackage#getTypeReference()
 * @model abstract="true"
 * @generated
 */
public interface TypeReference extends Commentable
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Returns the type referenced by this <code>TypeReference</code>
   *  considering all concrete subclasses of <code>TypeReference</code> used
   *  by the Java metamodel. 
   *  
   *  @param _this 
   *  @return the type
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return getBoundTarget ( null ) ; \n'"
   * @generated
   */
  Type getTarget();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Returns the type referenced by this <code>TypeReference</code>
   *  considering all concrete subclasses of <code>TypeReference</code> used
   *  by the Java metamodel. If type parameters are bound in the given reference,
   *  the bound type will be returned instead of the parameter.
   *  
   *  @return the type
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='org.emftext.language.java.types.Type type = null ; \nif ( this instanceof org.emftext.language.java.types.ClassifierReference || this instanceof org.emftext.language.java.types.NamespaceClassifierReference ) { \n\torg.emftext.language.java.types.ClassifierReference classifierRef = getPureClassifierReference ( ) ; \n\tif ( classifierRef != null ) { \n\t\ttype = classifierRef .getTarget ( ) ; \n\t} \n\tif ( reference instanceof org.emftext.language.java.references.MethodCall ) { \n\t\torg.emftext.language.java.references.MethodCall potentialCloneCall = ( org.emftext.language.java.references.MethodCall ) reference ; \n\t\t//clone returns the type of the cloned in the case of arrays\nif ( \"clone\" .equals ( potentialCloneCall .getTarget ( ) .getName ( ) ) ) { \n\t\t\tif ( potentialCloneCall .getPrevious ( ) instanceof org.emftext.language.java.references.ElementReference ) { \n\t\t\t\torg.emftext.language.java.references.ElementReference prevRef = ( org.emftext.language.java.references.ElementReference ) potentialCloneCall .getPrevious ( ) ; \n\t\t\t\tif ( prevRef .getTarget ( ) instanceof org.emftext.language.java.arrays.ArrayTypeable && ( ( org.emftext.language.java.arrays.ArrayTypeable ) prevRef .getTarget ( ) ) .getArrayDimension ( ) > 0 ) { \n\t\t\t\t\ttype = prevRef .getReferencedType ( ) ; \n\t\t\t\t} \n\t\t\t} \n\t\t} \n\t} \n} else if ( this instanceof org.emftext.language.java.types.PrimitiveType ) { \n\treturn ( org.emftext.language.java.types.PrimitiveType ) this ; \n} \n//resolve parameter to real type\nif ( type instanceof org.emftext.language.java.generics.TypeParameter ) { \n\ttype = ( ( org.emftext.language.java.generics.TypeParameter ) type ) .getBoundType ( this , reference ) ; \n} \nif ( type != null && type .eIsProxy ( ) ) { \n\t//this may happen, when e.g. a super type is resolved. It is ok.\nreturn null ; \n} \nreturn type ; \n'"
   * @generated
   */
  Type getBoundTarget(Reference reference);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Extracts the (possibly nested) classifier reference (if any) 
   *  from this type references.
   *  
   *  @return
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.emftext.language.java.types.ClassifierReference classifierReference = null ; \nif ( this instanceof org.emftext.language.java.types.ClassifierReference ) { \n\tclassifierReference = ( org.emftext.language.java.types.ClassifierReference ) this ; \n} \nif ( this instanceof org.emftext.language.java.types.NamespaceClassifierReference ) { \n\torg.emftext.language.java.types.NamespaceClassifierReference nsClassifierReference = ( org.emftext.language.java.types.NamespaceClassifierReference ) this ; \n\tif ( ! nsClassifierReference .getClassifierReferences ( ) .isEmpty ( ) ) { \n\t\tint lastIndex = nsClassifierReference .getClassifierReferences ( ) .size ( ) - 1 ; \n\t\tclassifierReference = nsClassifierReference .getClassifierReferences ( ) .get ( lastIndex ) ; \n\t} \n} \nreturn classifierReference ; \n'"
   * @generated
   */
  ClassifierReference getPureClassifierReference();

} // TypeReference
