/*******************************************************************************
 * Copyright (c) 2006-2010 
 * Software Technology Group, Dresden University of Technology
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany 
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.java.resource.java.grammar;

public class JavaGrammarInformationProvider {
	
	public final static org.eclipse.emf.ecore.EStructuralFeature ANONYMOUS_FEATURE = org.eclipse.emf.ecore.EcoreFactory.eINSTANCE.createEAttribute();
	static {
		ANONYMOUS_FEATURE.setName("_");
	}
	
	public static class Rule extends org.emftext.language.java.resource.java.grammar.JavaSyntaxElement {
		
		private final org.eclipse.emf.ecore.EClass metaclass;
		
		public Rule(org.eclipse.emf.ecore.EClass metaclass, org.emftext.language.java.resource.java.grammar.JavaChoice choice, org.emftext.language.java.resource.java.grammar.JavaCardinality cardinality) {
			super(cardinality, new org.emftext.language.java.resource.java.grammar.JavaSyntaxElement[] {choice});
			this.metaclass = metaclass;
		}
		
		public org.eclipse.emf.ecore.EClass getMetaclass() {
			return metaclass;
		}
		
		public org.emftext.language.java.resource.java.grammar.JavaChoice getDefinition() {
			return (org.emftext.language.java.resource.java.grammar.JavaChoice) getChildren()[0];
		}
	}
	
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_0_0_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getEmptyModel().getEStructuralFeature(org.emftext.language.java.containers.ContainersPackage.EMPTY_MODEL__IMPORTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_0_0_0_0_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_0_0_0_0_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_0_0_0_0_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_0_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_0_0_0_0_0_0_0, JAVA_0_0_0_0_0_0_1, JAVA_0_0_0_0_0_0_2, JAVA_0_0_0_0_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_0_0_0_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_0_0_0_0_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_0_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_0_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_0_0_0_1_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_0_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_0_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_0_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_0_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_0_0_0_0, JAVA_0_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_0_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_0_0_0);
	public final static Rule JAVA_0 = new Rule(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getEmptyModel(), JAVA_0_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getPackage().getEStructuralFeature(org.emftext.language.java.containers.ContainersPackage.PACKAGE__ANNOTATIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("package", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_1_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getPackage().getEStructuralFeature(org.emftext.language.java.containers.ContainersPackage.PACKAGE__NAMESPACES), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_1_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_1_0_0_2_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_1_0_0_2_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_1_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_1_0_0_2_0_0_0, JAVA_1_0_0_2_0_0_1, JAVA_1_0_0_2_0_0_2, JAVA_1_0_0_2_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_1_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_1_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_1_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getPackage().getEStructuralFeature(org.emftext.language.java.containers.ContainersPackage.PACKAGE__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_1_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_1_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_1_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_1_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_1_0_0_6_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_1_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_1_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_1_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_1_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_1_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_1_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_1_0_0_9_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getPackage().getEStructuralFeature(org.emftext.language.java.containers.ContainersPackage.PACKAGE__IMPORTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_1_0_0_9_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_1_0_0_9_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_1_0_0_9_0_0_0, JAVA_1_0_0_9_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_1_0_0_9_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_1_0_0_9_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_1_0_0_9 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_1_0_0_9_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_1_0_0_10_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_1_0_0_10_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_1_0_0_10_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_1_0_0_10_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_1_0_0_10_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_1_0_0_10 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_1_0_0_10_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_1_0_0_0, JAVA_1_0_0_1, JAVA_1_0_0_2, JAVA_1_0_0_3, JAVA_1_0_0_4, JAVA_1_0_0_5, JAVA_1_0_0_6, JAVA_1_0_0_7, JAVA_1_0_0_8, JAVA_1_0_0_9, JAVA_1_0_0_10);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_1_0_0);
	public final static Rule JAVA_1 = new Rule(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getPackage(), JAVA_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_2_0_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("package", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_2_0_0_0_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getCompilationUnit().getEStructuralFeature(org.emftext.language.java.containers.ContainersPackage.COMPILATION_UNIT__NAMESPACES), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_2_0_0_0_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_2_0_0_0_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_2_0_0_0_0_0_2_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_2_0_0_0_0_0_2_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getCompilationUnit().getEStructuralFeature(org.emftext.language.java.containers.ContainersPackage.COMPILATION_UNIT__NAMESPACES), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_2_0_0_0_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_0_0_0_2_0_0_0, JAVA_2_0_0_0_0_0_2_0_0_1, JAVA_2_0_0_0_0_0_2_0_0_2, JAVA_2_0_0_0_0_0_2_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_2_0_0_0_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_0_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_2_0_0_0_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_2_0_0_0_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_2_0_0_0_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_2_0_0_0_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_2_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_0_0_0_0, JAVA_2_0_0_0_0_0_1, JAVA_2_0_0_0_0_0_2, JAVA_2_0_0_0_0_0_3, JAVA_2_0_0_0_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_2_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_2_0_0_0_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_2_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_2_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getCompilationUnit().getEStructuralFeature(org.emftext.language.java.containers.ContainersPackage.COMPILATION_UNIT__IMPORTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_2_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_2_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_3_0_0_0, JAVA_2_0_0_3_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_2_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_2_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_2_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_2_0_0_4_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_2_0_0_4_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_2_0_0_4_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_4_0_0_0, JAVA_2_0_0_4_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_2_0_0_4_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_4_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_2_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_2_0_0_4_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_2_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_2_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getCompilationUnit().getEStructuralFeature(org.emftext.language.java.containers.ContainersPackage.COMPILATION_UNIT__CLASSIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_2_0_0_6_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_2_0_0_6_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_6_0_0_1_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_2_0_0_6_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_6_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_2_0_0_6_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_2_0_0_6_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_2_0_0_6_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_2_0_0_6_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_2_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_6_0_0_0, JAVA_2_0_0_6_0_0_1, JAVA_2_0_0_6_0_0_2, JAVA_2_0_0_6_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_2_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_2_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_2_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.PLUS);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_2_0_0_7_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("\u001a", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_2_0_0_7_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_7_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_2_0_0_7_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_7_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_2_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_2_0_0_7_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0_0, JAVA_2_0_0_1, JAVA_2_0_0_2, JAVA_2_0_0_3, JAVA_2_0_0_4, JAVA_2_0_0_5, JAVA_2_0_0_6, JAVA_2_0_0_7);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_2_0_0);
	public final static Rule JAVA_2 = new Rule(org.emftext.language.java.containers.ContainersPackage.eINSTANCE.getCompilationUnit(), JAVA_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("import", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_3_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getClassifierImport().getEStructuralFeature(org.emftext.language.java.imports.ImportsPackage.CLASSIFIER_IMPORT__NAMESPACES), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_3_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_3_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_3_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_3_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_3_0_0_1_0_0_0, JAVA_3_0_0_1_0_0_1, JAVA_3_0_0_1_0_0_2, JAVA_3_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_3_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_3_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_3_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_3_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getClassifierImport().getEStructuralFeature(org.emftext.language.java.imports.ImportsPackage.CLASSIFIER_IMPORT__CLASSIFIER), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_3_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_3_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_3_0_0_0, JAVA_3_0_0_1, JAVA_3_0_0_2, JAVA_3_0_0_3, JAVA_3_0_0_4, JAVA_3_0_0_5);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_3_0_0);
	public final static Rule JAVA_3 = new Rule(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getClassifierImport(), JAVA_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_4_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("import", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_4_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getPackageImport().getEStructuralFeature(org.emftext.language.java.imports.ImportsPackage.PACKAGE_IMPORT__NAMESPACES), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_4_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_4_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_4_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_4_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_4_0_0_1_0_0_0, JAVA_4_0_0_1_0_0_1, JAVA_4_0_0_1_0_0_2, JAVA_4_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_4_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_4_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_4_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_4_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.PLUS);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_4_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_4_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("*", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_4_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_4_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_4_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_4_0_0_0, JAVA_4_0_0_1, JAVA_4_0_0_2, JAVA_4_0_0_3, JAVA_4_0_0_4, JAVA_4_0_0_5);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_4_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_4_0_0);
	public final static Rule JAVA_4 = new Rule(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getPackageImport(), JAVA_4_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("import", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_5_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getStaticMemberImport().getEStructuralFeature(org.emftext.language.java.imports.ImportsPackage.STATIC_MEMBER_IMPORT__STATIC), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_5_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getStaticMemberImport().getEStructuralFeature(org.emftext.language.java.imports.ImportsPackage.STATIC_MEMBER_IMPORT__NAMESPACES), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_5_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_5_0_0_2_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_5_0_0_2_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_5_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_5_0_0_2_0_0_0, JAVA_5_0_0_2_0_0_1, JAVA_5_0_0_2_0_0_2, JAVA_5_0_0_2_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_5_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_5_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_5_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_5_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_5_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_5_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getStaticMemberImport().getEStructuralFeature(org.emftext.language.java.imports.ImportsPackage.STATIC_MEMBER_IMPORT__STATIC_MEMBERS), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_5_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_5_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_5_0_0_0, JAVA_5_0_0_1, JAVA_5_0_0_2, JAVA_5_0_0_3, JAVA_5_0_0_4, JAVA_5_0_0_5, JAVA_5_0_0_6);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_5_0_0);
	public final static Rule JAVA_5 = new Rule(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getStaticMemberImport(), JAVA_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("import", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_6_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getStaticClassifierImport().getEStructuralFeature(org.emftext.language.java.imports.ImportsPackage.STATIC_CLASSIFIER_IMPORT__STATIC), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_6_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getStaticClassifierImport().getEStructuralFeature(org.emftext.language.java.imports.ImportsPackage.STATIC_CLASSIFIER_IMPORT__NAMESPACES), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_6_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_6_0_0_2_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_6_0_0_2_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_6_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_6_0_0_2_0_0_0, JAVA_6_0_0_2_0_0_1, JAVA_6_0_0_2_0_0_2, JAVA_6_0_0_2_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_6_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_6_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_6_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_6_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.PLUS);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_6_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_6_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("*", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_6_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_6_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_6_0_0_0, JAVA_6_0_0_1, JAVA_6_0_0_2, JAVA_6_0_0_3, JAVA_6_0_0_4, JAVA_6_0_0_5, JAVA_6_0_0_6);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_6_0_0);
	public final static Rule JAVA_6 = new Rule(org.emftext.language.java.imports.ImportsPackage.eINSTANCE.getStaticClassifierImport(), JAVA_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_7_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getClass_().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.CLASS__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_7_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("class", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_7_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getClass_().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.CLASS__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_7_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_7_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getClass_().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.CLASS__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_7_0_0_3_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_7_0_0_3_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getClass_().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.CLASS__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_7_0_0_3_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_3_0_0_2_0_0_0, JAVA_7_0_0_3_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_7_0_0_3_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_3_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_7_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_7_0_0_3_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_7_0_0_3_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_7_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_3_0_0_0, JAVA_7_0_0_3_0_0_1, JAVA_7_0_0_3_0_0_2, JAVA_7_0_0_3_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_7_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_7_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_7_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_7_0_0_4_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("extends", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_7_0_0_4_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getClass_().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.CLASS__EXTENDS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_7_0_0_4_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_4_0_0_0, JAVA_7_0_0_4_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_7_0_0_4_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_4_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_7_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_7_0_0_4_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_7_0_0_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("implements", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_7_0_0_5_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getClass_().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.CLASS__IMPLEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_7_0_0_5_0_0_1_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_7_0_0_5_0_0_1_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getClass_().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.CLASS__IMPLEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_7_0_0_5_0_0_1_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_5_0_0_1_0_0_1_0_0_0, JAVA_7_0_0_5_0_0_1_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_7_0_0_5_0_0_1_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_5_0_0_1_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_7_0_0_5_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_7_0_0_5_0_0_1_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_7_0_0_5_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_5_0_0_1_0_0_0, JAVA_7_0_0_5_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_7_0_0_5_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_5_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_7_0_0_5_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_7_0_0_5_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_7_0_0_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_5_0_0_0, JAVA_7_0_0_5_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_7_0_0_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_5_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_7_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_7_0_0_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_7_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_7_0_0_7_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_7_0_0_7_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getClass_().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.CLASS__MEMBERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_7_0_0_7_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_7_0_0_0, JAVA_7_0_0_7_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_7_0_0_7_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_7_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_7_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_7_0_0_7_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_7_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_7_0_0_9 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_7_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0_0, JAVA_7_0_0_1, JAVA_7_0_0_2, JAVA_7_0_0_3, JAVA_7_0_0_4, JAVA_7_0_0_5, JAVA_7_0_0_6, JAVA_7_0_0_7, JAVA_7_0_0_8, JAVA_7_0_0_9);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_7_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_7_0_0);
	public final static Rule JAVA_7 = new Rule(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getClass_(), JAVA_7_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_8_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_8_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_8_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getAnonymousClass().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ANONYMOUS_CLASS__MEMBERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_8_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_8_0_0_1_0_0_0, JAVA_8_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_8_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_8_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_8_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_8_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_8_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_8_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_8_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_8_0_0_0, JAVA_8_0_0_1, JAVA_8_0_0_2, JAVA_8_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_8_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_8_0_0);
	public final static Rule JAVA_8 = new Rule(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getAnonymousClass(), JAVA_8_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_9_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getInterface().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.INTERFACE__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_9_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("interface", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_9_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getInterface().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.INTERFACE__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_9_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_9_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_9_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getInterface().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.INTERFACE__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_9_0_0_3_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_9_0_0_3_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_9_0_0_3_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getInterface().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.INTERFACE__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_9_0_0_3_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_3_0_0_3_0_0_0, JAVA_9_0_0_3_0_0_3_0_0_1, JAVA_9_0_0_3_0_0_3_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_9_0_0_3_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_3_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_9_0_0_3_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_9_0_0_3_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_9_0_0_3_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_9_0_0_3_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_9_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_3_0_0_0, JAVA_9_0_0_3_0_0_1, JAVA_9_0_0_3_0_0_2, JAVA_9_0_0_3_0_0_3, JAVA_9_0_0_3_0_0_4, JAVA_9_0_0_3_0_0_5);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_9_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_9_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_9_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_9_0_0_4_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("extends", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_9_0_0_4_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getInterface().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.INTERFACE__EXTENDS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_9_0_0_4_0_0_1_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_9_0_0_4_0_0_1_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getInterface().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.INTERFACE__EXTENDS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_9_0_0_4_0_0_1_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_4_0_0_1_0_0_1_0_0_0, JAVA_9_0_0_4_0_0_1_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_9_0_0_4_0_0_1_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_4_0_0_1_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_9_0_0_4_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_9_0_0_4_0_0_1_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_9_0_0_4_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_4_0_0_1_0_0_0, JAVA_9_0_0_4_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_9_0_0_4_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_4_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_9_0_0_4_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_9_0_0_4_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_9_0_0_4_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_4_0_0_0, JAVA_9_0_0_4_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_9_0_0_4_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_4_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_9_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_9_0_0_4_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_9_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_9_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_9_0_0_6_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getInterface().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.INTERFACE__MEMBERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_9_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_6_0_0_0, JAVA_9_0_0_6_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_9_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_9_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_9_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_9_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_9_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_9_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0_0, JAVA_9_0_0_1, JAVA_9_0_0_2, JAVA_9_0_0_3, JAVA_9_0_0_4, JAVA_9_0_0_5, JAVA_9_0_0_6, JAVA_9_0_0_7, JAVA_9_0_0_8);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_9_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_9_0_0);
	public final static Rule JAVA_9 = new Rule(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getInterface(), JAVA_9_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_10_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getEnumeration().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ENUMERATION__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_10_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("enum", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_10_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getEnumeration().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ENUMERATION__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_10_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("implements", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_10_0_0_3_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getEnumeration().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ENUMERATION__IMPLEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_10_0_0_3_0_0_1_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_10_0_0_3_0_0_1_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getEnumeration().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ENUMERATION__IMPLEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_10_0_0_3_0_0_1_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_3_0_0_1_0_0_1_0_0_0, JAVA_10_0_0_3_0_0_1_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_10_0_0_3_0_0_1_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_3_0_0_1_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_10_0_0_3_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_10_0_0_3_0_0_1_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_10_0_0_3_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_3_0_0_1_0_0_0, JAVA_10_0_0_3_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_10_0_0_3_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_3_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_10_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_10_0_0_3_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_10_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_3_0_0_0, JAVA_10_0_0_3_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_10_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_10_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_10_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_10_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_10_0_0_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_10_0_0_5_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getEnumeration().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ENUMERATION__CONSTANTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_10_0_0_5_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_10_0_0_5_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_10_0_0_5_0_0_2_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getEnumeration().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ENUMERATION__CONSTANTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_10_0_0_5_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_5_0_0_2_0_0_0, JAVA_10_0_0_5_0_0_2_0_0_1, JAVA_10_0_0_5_0_0_2_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_10_0_0_5_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_5_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_10_0_0_5_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_10_0_0_5_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_10_0_0_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_5_0_0_0, JAVA_10_0_0_5_0_0_1, JAVA_10_0_0_5_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_10_0_0_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_5_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_10_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_10_0_0_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_10_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_10_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_6_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_10_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_10_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_10_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_10_0_0_7_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_10_0_0_7_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_10_0_0_7_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getEnumeration().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ENUMERATION__MEMBERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_10_0_0_7_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_7_0_0_1_0_0_0, JAVA_10_0_0_7_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_10_0_0_7_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_7_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_10_0_0_7_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_10_0_0_7_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_10_0_0_7_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_10_0_0_7_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_7_0_0_0, JAVA_10_0_0_7_0_0_1, JAVA_10_0_0_7_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_10_0_0_7_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_7_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_10_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_10_0_0_7_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_10_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_10_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0_0, JAVA_10_0_0_1, JAVA_10_0_0_2, JAVA_10_0_0_3, JAVA_10_0_0_4, JAVA_10_0_0_5, JAVA_10_0_0_6, JAVA_10_0_0_7, JAVA_10_0_0_8);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_10_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_10_0_0);
	public final static Rule JAVA_10 = new Rule(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getEnumeration(), JAVA_10_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_11_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getAnnotation().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ANNOTATION__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_11_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("@", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_11_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("interface", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_11_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getAnnotation().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ANNOTATION__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_11_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_11_0_0_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_11_0_0_5_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getAnnotation().getEStructuralFeature(org.emftext.language.java.classifiers.ClassifiersPackage.ANNOTATION__MEMBERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_11_0_0_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_11_0_0_5_0_0_0, JAVA_11_0_0_5_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_11_0_0_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_11_0_0_5_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_11_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_11_0_0_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_11_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_11_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_11_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_11_0_0_0, JAVA_11_0_0_1, JAVA_11_0_0_2, JAVA_11_0_0_3, JAVA_11_0_0_4, JAVA_11_0_0_5, JAVA_11_0_0_6, JAVA_11_0_0_7);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_11_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_11_0_0);
	public final static Rule JAVA_11 = new Rule(org.emftext.language.java.classifiers.ClassifiersPackage.eINSTANCE.getAnnotation(), JAVA_11_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_12_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("@", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_12_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationInstance().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_INSTANCE__NAMESPACES), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_12_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_12_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_12_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_12_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_12_0_0_1_0_0_0, JAVA_12_0_0_1_0_0_1, JAVA_12_0_0_1_0_0_2, JAVA_12_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_12_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_12_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_12_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_12_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_12_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationInstance().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_INSTANCE__ANNOTATION), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_12_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationInstance().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_INSTANCE__PARAMETER), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_12_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_12_0_0_3_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_12_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_12_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_12_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_12_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_12_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_12_0_0_0, JAVA_12_0_0_1, JAVA_12_0_0_2, JAVA_12_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_12_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_12_0_0);
	public final static Rule JAVA_12 = new Rule(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationInstance(), JAVA_12_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_13_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_13_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getSingleAnnotationParameter().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.SINGLE_ANNOTATION_PARAMETER__VALUE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_13_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_13_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_13_0_0_0, JAVA_13_0_0_1, JAVA_13_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_13_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_13_0_0);
	public final static Rule JAVA_13 = new Rule(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getSingleAnnotationParameter(), JAVA_13_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_14_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_14_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationParameterList().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_PARAMETER_LIST__SETTINGS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_14_0_0_1_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_14_0_0_1_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationParameterList().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_PARAMETER_LIST__SETTINGS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_14_0_0_1_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_14_0_0_1_0_0_1_0_0_0, JAVA_14_0_0_1_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_14_0_0_1_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_14_0_0_1_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_14_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_14_0_0_1_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_14_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_14_0_0_1_0_0_0, JAVA_14_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_14_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_14_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_14_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_14_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_14_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_14_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_14_0_0_0, JAVA_14_0_0_1, JAVA_14_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_14_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_14_0_0);
	public final static Rule JAVA_14 = new Rule(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationParameterList(), JAVA_14_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_15_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttributeSetting().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE_SETTING__ATTRIBUTE), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_15_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_15_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttributeSetting().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE_SETTING__VALUE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_15_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_15_0_0_0, JAVA_15_0_0_1, JAVA_15_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_15_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_15_0_0);
	public final static Rule JAVA_15 = new Rule(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttributeSetting(), JAVA_15_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_16_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getTypeParameter().getEStructuralFeature(org.emftext.language.java.generics.GenericsPackage.TYPE_PARAMETER__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_16_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("extends", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_16_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getTypeParameter().getEStructuralFeature(org.emftext.language.java.generics.GenericsPackage.TYPE_PARAMETER__EXTEND_TYPES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_16_0_0_1_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("&", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_16_0_0_1_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getTypeParameter().getEStructuralFeature(org.emftext.language.java.generics.GenericsPackage.TYPE_PARAMETER__EXTEND_TYPES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_16_0_0_1_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_16_0_0_1_0_0_2_0_0_0, JAVA_16_0_0_1_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_16_0_0_1_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_16_0_0_1_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_16_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_16_0_0_1_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_16_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_16_0_0_1_0_0_0, JAVA_16_0_0_1_0_0_1, JAVA_16_0_0_1_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_16_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_16_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_16_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_16_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_16_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_16_0_0_0, JAVA_16_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_16_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_16_0_0);
	public final static Rule JAVA_16 = new Rule(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getTypeParameter(), JAVA_16_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_17_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getEnumConstant().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.ENUM_CONSTANT__ANNOTATIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_17_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.members.MembersPackage.eINSTANCE.getEnumConstant().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.ENUM_CONSTANT__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_17_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_17_0_0_2_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getEnumConstant().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.ENUM_CONSTANT__ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_17_0_0_2_0_0_1_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_17_0_0_2_0_0_1_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getEnumConstant().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.ENUM_CONSTANT__ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_17_0_0_2_0_0_1_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_17_0_0_2_0_0_1_0_0_1_0_0_0, JAVA_17_0_0_2_0_0_1_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_17_0_0_2_0_0_1_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_17_0_0_2_0_0_1_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_17_0_0_2_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_17_0_0_2_0_0_1_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_17_0_0_2_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_17_0_0_2_0_0_1_0_0_0, JAVA_17_0_0_2_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_17_0_0_2_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_17_0_0_2_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_17_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_17_0_0_2_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_17_0_0_2_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_17_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_17_0_0_2_0_0_0, JAVA_17_0_0_2_0_0_1, JAVA_17_0_0_2_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_17_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_17_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_17_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_17_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_17_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getEnumConstant().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.ENUM_CONSTANT__ANONYMOUS_CLASS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_17_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_17_0_0_3_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_17_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_17_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_17_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_17_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_17_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_17_0_0_0, JAVA_17_0_0_1, JAVA_17_0_0_2, JAVA_17_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_17_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_17_0_0);
	public final static Rule JAVA_17 = new Rule(org.emftext.language.java.members.MembersPackage.eINSTANCE.getEnumConstant(), JAVA_17_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_18_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getBlock().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.BLOCK__MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_18_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_18_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_18_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getBlock().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.BLOCK__STATEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_18_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_18_0_0_2_0_0_0, JAVA_18_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_18_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_18_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_18_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_18_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_18_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_18_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_18_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_18_0_0_0, JAVA_18_0_0_1, JAVA_18_0_0_2, JAVA_18_0_0_3, JAVA_18_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_18_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_18_0_0);
	public final static Rule JAVA_18 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getBlock(), JAVA_18_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_19_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getConstructor().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CONSTRUCTOR__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_19_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_19_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getConstructor().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CONSTRUCTOR__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_19_0_0_1_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_19_0_0_1_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getConstructor().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CONSTRUCTOR__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_19_0_0_1_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_1_0_0_2_0_0_0, JAVA_19_0_0_1_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_19_0_0_1_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_1_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_19_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_19_0_0_1_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_19_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_19_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_1_0_0_0, JAVA_19_0_0_1_0_0_1, JAVA_19_0_0_1_0_0_2, JAVA_19_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_19_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_19_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_19_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_19_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.members.MembersPackage.eINSTANCE.getConstructor().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CONSTRUCTOR__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_19_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_19_0_0_4_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getConstructor().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CONSTRUCTOR__PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_19_0_0_4_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_19_0_0_4_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getConstructor().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CONSTRUCTOR__PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_19_0_0_4_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_4_0_0_1_0_0_0, JAVA_19_0_0_4_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_19_0_0_4_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_4_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_19_0_0_4_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_19_0_0_4_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_19_0_0_4_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_4_0_0_0, JAVA_19_0_0_4_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_19_0_0_4_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_4_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_19_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_19_0_0_4_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_19_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_19_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("throws", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_19_0_0_6_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getConstructor().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CONSTRUCTOR__EXCEPTIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_19_0_0_6_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_19_0_0_6_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getConstructor().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CONSTRUCTOR__EXCEPTIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_19_0_0_6_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_6_0_0_2_0_0_0, JAVA_19_0_0_6_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_19_0_0_6_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_6_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_19_0_0_6_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_19_0_0_6_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_19_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_6_0_0_0, JAVA_19_0_0_6_0_0_1, JAVA_19_0_0_6_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_19_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_19_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_19_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_19_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_19_0_0_8_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_19_0_0_8_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getConstructor().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CONSTRUCTOR__STATEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_19_0_0_8_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_8_0_0_0, JAVA_19_0_0_8_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_19_0_0_8_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_8_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_19_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_19_0_0_8_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_19_0_0_9 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_19_0_0_10 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_19_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0_0, JAVA_19_0_0_1, JAVA_19_0_0_2, JAVA_19_0_0_3, JAVA_19_0_0_4, JAVA_19_0_0_5, JAVA_19_0_0_6, JAVA_19_0_0_7, JAVA_19_0_0_8, JAVA_19_0_0_9, JAVA_19_0_0_10);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_19_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_19_0_0);
	public final static Rule JAVA_19 = new Rule(org.emftext.language.java.members.MembersPackage.eINSTANCE.getConstructor(), JAVA_19_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_20_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_20_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_20_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_20_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_20_0_0_1_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_20_0_0_1_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_20_0_0_1_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_20_0_0_1_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_1_0_0_3_0_0_0, JAVA_20_0_0_1_0_0_3_0_0_1, JAVA_20_0_0_1_0_0_3_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_20_0_0_1_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_1_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_20_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_20_0_0_1_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_20_0_0_1_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_20_0_0_1_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_20_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_1_0_0_0, JAVA_20_0_0_1_0_0_1, JAVA_20_0_0_1_0_0_2, JAVA_20_0_0_1_0_0_3, JAVA_20_0_0_1_0_0_4, JAVA_20_0_0_1_0_0_5);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_20_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_20_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_20_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_20_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_20_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_20_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_2_0_0_0, JAVA_20_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_20_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_20_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_20_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_20_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_20_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_20_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_20_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_20_0_0_6_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_20_0_0_6_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_20_0_0_6_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_6_0_0_1_0_0_0, JAVA_20_0_0_6_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_20_0_0_6_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_6_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_20_0_0_6_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_20_0_0_6_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_20_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_6_0_0_0, JAVA_20_0_0_6_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_20_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_20_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_20_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_20_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_20_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_20_0_0_9 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__ARRAY_DIMENSIONS_AFTER), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_20_0_0_10_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("throws", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_20_0_0_10_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__EXCEPTIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_20_0_0_10_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_20_0_0_10_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.INTERFACE_METHOD__EXCEPTIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_20_0_0_10_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_10_0_0_2_0_0_0, JAVA_20_0_0_10_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_20_0_0_10_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_10_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_20_0_0_10_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_20_0_0_10_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_20_0_0_10_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_10_0_0_0, JAVA_20_0_0_10_0_0_1, JAVA_20_0_0_10_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_20_0_0_10_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_10_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_20_0_0_10 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_20_0_0_10_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_20_0_0_11 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_20_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0_0, JAVA_20_0_0_1, JAVA_20_0_0_2, JAVA_20_0_0_3, JAVA_20_0_0_4, JAVA_20_0_0_5, JAVA_20_0_0_6, JAVA_20_0_0_7, JAVA_20_0_0_8, JAVA_20_0_0_9, JAVA_20_0_0_10, JAVA_20_0_0_11);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_20_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_20_0_0);
	public final static Rule JAVA_20 = new Rule(org.emftext.language.java.members.MembersPackage.eINSTANCE.getInterfaceMethod(), JAVA_20_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_21_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_21_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_21_0_0_1_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_21_0_0_1_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_1_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_21_0_0_1_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_1_0_0_3_0_0_0, JAVA_21_0_0_1_0_0_3_0_0_1, JAVA_21_0_0_1_0_0_3_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_21_0_0_1_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_1_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_21_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_21_0_0_1_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_21_0_0_1_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_21_0_0_1_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_21_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_1_0_0_0, JAVA_21_0_0_1_0_0_1, JAVA_21_0_0_1_0_0_2, JAVA_21_0_0_1_0_0_3, JAVA_21_0_0_1_0_0_4, JAVA_21_0_0_1_0_0_5);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_21_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_21_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_21_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_21_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_2_0_0_0, JAVA_21_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_21_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_21_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_21_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_21_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_21_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_21_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_21_0_0_6_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_6_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_21_0_0_6_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_6_0_0_1_0_0_0, JAVA_21_0_0_6_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_21_0_0_6_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_6_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_21_0_0_6_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_21_0_0_6_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_21_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_6_0_0_0, JAVA_21_0_0_6_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_21_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_21_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_21_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_21_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_21_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_9 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__ARRAY_DIMENSIONS_AFTER), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_21_0_0_10_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("throws", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_10_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__EXCEPTIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_21_0_0_10_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_10_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__EXCEPTIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_21_0_0_10_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_10_0_0_2_0_0_0, JAVA_21_0_0_10_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_21_0_0_10_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_10_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_21_0_0_10_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_21_0_0_10_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_21_0_0_10_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_10_0_0_0, JAVA_21_0_0_10_0_0_1, JAVA_21_0_0_10_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_21_0_0_10_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_10_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_21_0_0_10 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_21_0_0_10_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_21_0_0_11 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_21_0_0_12_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_21_0_0_12_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.CLASS_METHOD__STATEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_21_0_0_12_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_12_0_0_0, JAVA_21_0_0_12_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_21_0_0_12_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_12_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_21_0_0_12 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_21_0_0_12_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_21_0_0_13 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_21_0_0_14 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_21_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0_0, JAVA_21_0_0_1, JAVA_21_0_0_2, JAVA_21_0_0_3, JAVA_21_0_0_4, JAVA_21_0_0_5, JAVA_21_0_0_6, JAVA_21_0_0_7, JAVA_21_0_0_8, JAVA_21_0_0_9, JAVA_21_0_0_10, JAVA_21_0_0_11, JAVA_21_0_0_12, JAVA_21_0_0_13, JAVA_21_0_0_14);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_21_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_21_0_0);
	public final static Rule JAVA_21 = new Rule(org.emftext.language.java.members.MembersPackage.eINSTANCE.getClassMethod(), JAVA_21_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_22_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_22_0_0_1_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_1_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__TYPE_PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_22_0_0_1_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_1_0_0_2_0_0_0, JAVA_22_0_0_1_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_22_0_0_1_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_1_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_22_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_22_0_0_1_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_22_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_22_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_1_0_0_0, JAVA_22_0_0_1_0_0_1, JAVA_22_0_0_1_0_0_2, JAVA_22_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_22_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_22_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_22_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_22_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_2_0_0_0, JAVA_22_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_22_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_22_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_22_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_22_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_22_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_22_0_0_5_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_5_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__PARAMETERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_22_0_0_5_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_5_0_0_1_0_0_0, JAVA_22_0_0_5_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_22_0_0_5_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_5_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_22_0_0_5_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_22_0_0_5_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_22_0_0_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_5_0_0_0, JAVA_22_0_0_5_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_22_0_0_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_5_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_22_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_22_0_0_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_22_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__ARRAY_DIMENSIONS_AFTER), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_22_0_0_8_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("throws", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_8_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__EXCEPTIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_22_0_0_8_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_8_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__EXCEPTIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_22_0_0_8_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_8_0_0_2_0_0_0, JAVA_22_0_0_8_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_22_0_0_8_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_8_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_22_0_0_8_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_22_0_0_8_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_22_0_0_8_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_8_0_0_0, JAVA_22_0_0_8_0_0_1, JAVA_22_0_0_8_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_22_0_0_8_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_8_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_22_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_22_0_0_8_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_22_0_0_9 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("default", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_22_0_0_10 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute().getEStructuralFeature(org.emftext.language.java.annotations.AnnotationsPackage.ANNOTATION_ATTRIBUTE__DEFAULT_VALUE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_22_0_0_11 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_22_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0_0, JAVA_22_0_0_1, JAVA_22_0_0_2, JAVA_22_0_0_3, JAVA_22_0_0_4, JAVA_22_0_0_5, JAVA_22_0_0_6, JAVA_22_0_0_7, JAVA_22_0_0_8, JAVA_22_0_0_9, JAVA_22_0_0_10, JAVA_22_0_0_11);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_22_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_22_0_0);
	public final static Rule JAVA_22 = new Rule(org.emftext.language.java.annotations.AnnotationsPackage.eINSTANCE.getAnnotationAttribute(), JAVA_22_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_23_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getOrdinaryParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.ORDINARY_PARAMETER__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_23_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getOrdinaryParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.ORDINARY_PARAMETER__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_23_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getOrdinaryParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.ORDINARY_PARAMETER__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_23_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_23_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getOrdinaryParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.ORDINARY_PARAMETER__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_23_0_0_3_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_23_0_0_3_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getOrdinaryParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.ORDINARY_PARAMETER__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_23_0_0_3_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_23_0_0_3_0_0_2_0_0_0, JAVA_23_0_0_3_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_23_0_0_3_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_23_0_0_3_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_23_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_23_0_0_3_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_23_0_0_3_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_23_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_23_0_0_3_0_0_0, JAVA_23_0_0_3_0_0_1, JAVA_23_0_0_3_0_0_2, JAVA_23_0_0_3_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_23_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_23_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_23_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_23_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_23_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getOrdinaryParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.ORDINARY_PARAMETER__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_23_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getOrdinaryParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.ORDINARY_PARAMETER__ARRAY_DIMENSIONS_AFTER), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_23_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_23_0_0_0, JAVA_23_0_0_1, JAVA_23_0_0_2, JAVA_23_0_0_3, JAVA_23_0_0_4, JAVA_23_0_0_5);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_23_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_23_0_0);
	public final static Rule JAVA_23 = new Rule(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getOrdinaryParameter(), JAVA_23_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_24_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getVariableLengthParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.VARIABLE_LENGTH_PARAMETER__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_24_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getVariableLengthParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.VARIABLE_LENGTH_PARAMETER__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_24_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getVariableLengthParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.VARIABLE_LENGTH_PARAMETER__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_24_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_24_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getVariableLengthParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.VARIABLE_LENGTH_PARAMETER__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_24_0_0_3_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_24_0_0_3_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getVariableLengthParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.VARIABLE_LENGTH_PARAMETER__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_24_0_0_3_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_24_0_0_3_0_0_2_0_0_0, JAVA_24_0_0_3_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_24_0_0_3_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_24_0_0_3_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_24_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_24_0_0_3_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_24_0_0_3_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_24_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_24_0_0_3_0_0_0, JAVA_24_0_0_3_0_0_1, JAVA_24_0_0_3_0_0_2, JAVA_24_0_0_3_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_24_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_24_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_24_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_24_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_24_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("...", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_24_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getVariableLengthParameter().getEStructuralFeature(org.emftext.language.java.parameters.ParametersPackage.VARIABLE_LENGTH_PARAMETER__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_24_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_24_0_0_0, JAVA_24_0_0_1, JAVA_24_0_0_2, JAVA_24_0_0_3, JAVA_24_0_0_4, JAVA_24_0_0_5);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_24_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_24_0_0);
	public final static Rule JAVA_24 = new Rule(org.emftext.language.java.parameters.ParametersPackage.eINSTANCE.getVariableLengthParameter(), JAVA_24_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_25_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.LOCAL_VARIABLE__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_25_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.LOCAL_VARIABLE__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_25_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.LOCAL_VARIABLE__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_25_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_25_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.LOCAL_VARIABLE__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_25_0_0_3_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_25_0_0_3_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.LOCAL_VARIABLE__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_25_0_0_3_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_25_0_0_3_0_0_2_0_0_0, JAVA_25_0_0_3_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_25_0_0_3_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_25_0_0_3_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_25_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_25_0_0_3_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_25_0_0_3_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_25_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_25_0_0_3_0_0_0, JAVA_25_0_0_3_0_0_1, JAVA_25_0_0_3_0_0_2, JAVA_25_0_0_3_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_25_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_25_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_25_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_25_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_25_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.LOCAL_VARIABLE__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_25_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.LOCAL_VARIABLE__ARRAY_DIMENSIONS_AFTER), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_25_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_25_0_0_6_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.LOCAL_VARIABLE__INITIAL_VALUE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_25_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_25_0_0_6_0_0_0, JAVA_25_0_0_6_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_25_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_25_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_25_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_25_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_25_0_0_7_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_25_0_0_7_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.LOCAL_VARIABLE__ADDITIONAL_LOCAL_VARIABLES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_25_0_0_7_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_25_0_0_7_0_0_0, JAVA_25_0_0_7_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_25_0_0_7_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_25_0_0_7_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_25_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_25_0_0_7_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_25_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_25_0_0_0, JAVA_25_0_0_1, JAVA_25_0_0_2, JAVA_25_0_0_3, JAVA_25_0_0_4, JAVA_25_0_0_5, JAVA_25_0_0_6, JAVA_25_0_0_7);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_25_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_25_0_0);
	public final static Rule JAVA_25 = new Rule(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getLocalVariable(), JAVA_25_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_26_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getLocalVariableStatement().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.LOCAL_VARIABLE_STATEMENT__VARIABLE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_26_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_26_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_26_0_0_0, JAVA_26_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_26_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_26_0_0);
	public final static Rule JAVA_26 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getLocalVariableStatement(), JAVA_26_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_27_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getAdditionalLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.ADDITIONAL_LOCAL_VARIABLE__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_27_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getAdditionalLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.ADDITIONAL_LOCAL_VARIABLE__ARRAY_DIMENSIONS_AFTER), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_27_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_27_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getAdditionalLocalVariable().getEStructuralFeature(org.emftext.language.java.variables.VariablesPackage.ADDITIONAL_LOCAL_VARIABLE__INITIAL_VALUE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_27_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_27_0_0_2_0_0_0, JAVA_27_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_27_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_27_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_27_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_27_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_27_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_27_0_0_0, JAVA_27_0_0_1, JAVA_27_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_27_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_27_0_0);
	public final static Rule JAVA_27 = new Rule(org.emftext.language.java.variables.VariablesPackage.eINSTANCE.getAdditionalLocalVariable(), JAVA_27_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_28_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.FIELD__ANNOTATIONS_AND_MODIFIERS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_28_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.FIELD__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_28_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.FIELD__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_28_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_28_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.FIELD__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_28_0_0_3_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_28_0_0_3_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.FIELD__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_28_0_0_3_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_28_0_0_3_0_0_2_0_0_0, JAVA_28_0_0_3_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_28_0_0_3_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_28_0_0_3_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_28_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_28_0_0_3_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_28_0_0_3_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_28_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_28_0_0_3_0_0_0, JAVA_28_0_0_3_0_0_1, JAVA_28_0_0_3_0_0_2, JAVA_28_0_0_3_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_28_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_28_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_28_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_28_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_28_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.members.MembersPackage.eINSTANCE.getField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.FIELD__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_28_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.FIELD__ARRAY_DIMENSIONS_AFTER), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_28_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_28_0_0_6_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.FIELD__INITIAL_VALUE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_28_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_28_0_0_6_0_0_0, JAVA_28_0_0_6_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_28_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_28_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_28_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_28_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_28_0_0_7_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_28_0_0_7_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.FIELD__ADDITIONAL_FIELDS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_28_0_0_7_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_28_0_0_7_0_0_0, JAVA_28_0_0_7_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_28_0_0_7_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_28_0_0_7_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_28_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_28_0_0_7_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_28_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_28_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_28_0_0_0, JAVA_28_0_0_1, JAVA_28_0_0_2, JAVA_28_0_0_3, JAVA_28_0_0_4, JAVA_28_0_0_5, JAVA_28_0_0_6, JAVA_28_0_0_7, JAVA_28_0_0_8);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_28_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_28_0_0);
	public final static Rule JAVA_28 = new Rule(org.emftext.language.java.members.MembersPackage.eINSTANCE.getField(), JAVA_28_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_29_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.members.MembersPackage.eINSTANCE.getAdditionalField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.ADDITIONAL_FIELD__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_29_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getAdditionalField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.ADDITIONAL_FIELD__ARRAY_DIMENSIONS_AFTER), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_29_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_29_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.members.MembersPackage.eINSTANCE.getAdditionalField().getEStructuralFeature(org.emftext.language.java.members.MembersPackage.ADDITIONAL_FIELD__INITIAL_VALUE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_29_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_29_0_0_2_0_0_0, JAVA_29_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_29_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_29_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_29_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_29_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_29_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_29_0_0_0, JAVA_29_0_0_1, JAVA_29_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_29_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_29_0_0);
	public final static Rule JAVA_29 = new Rule(org.emftext.language.java.members.MembersPackage.eINSTANCE.getAdditionalField(), JAVA_29_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_30_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_30_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_30_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_30_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_30_0_0);
	public final static Rule JAVA_30 = new Rule(org.emftext.language.java.members.MembersPackage.eINSTANCE.getEmptyMember(), JAVA_30_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("new", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_31_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getNewConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.NEW_CONSTRUCTOR_CALL__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_1_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_31_0_0_1_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getNewConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.NEW_CONSTRUCTOR_CALL__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_31_0_0_1_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_1_0_0_2_0_0_0, JAVA_31_0_0_1_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_31_0_0_1_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_1_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_31_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_31_0_0_1_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_31_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_1_0_0_0, JAVA_31_0_0_1_0_0_1, JAVA_31_0_0_1_0_0_2, JAVA_31_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_31_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_31_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_31_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_31_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getNewConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.NEW_CONSTRUCTOR_CALL__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_31_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getNewConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.NEW_CONSTRUCTOR_CALL__CALL_TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_3_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_31_0_0_3_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getNewConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.NEW_CONSTRUCTOR_CALL__CALL_TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_31_0_0_3_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_3_0_0_2_0_0_0, JAVA_31_0_0_3_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_31_0_0_3_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_3_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_31_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_31_0_0_3_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_3_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_31_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_3_0_0_0, JAVA_31_0_0_3_0_0_1, JAVA_31_0_0_3_0_0_2, JAVA_31_0_0_3_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_31_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_31_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_31_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_31_0_0_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getNewConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.NEW_CONSTRUCTOR_CALL__ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_5_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_31_0_0_5_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getNewConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.NEW_CONSTRUCTOR_CALL__ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_31_0_0_5_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_5_0_0_1_0_0_0, JAVA_31_0_0_5_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_31_0_0_5_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_5_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_31_0_0_5_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_31_0_0_5_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_31_0_0_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_5_0_0_0, JAVA_31_0_0_5_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_31_0_0_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_5_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_31_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_31_0_0_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_31_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getNewConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.NEW_CONSTRUCTOR_CALL__ANONYMOUS_CLASS), org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_31_0_0_8_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_31_0_0_8_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_31_0_0_8_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_31_0_0_8_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getNewConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.NEW_CONSTRUCTOR_CALL__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_31_0_0_8_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_8_0_0_0, JAVA_31_0_0_8_0_0_1, JAVA_31_0_0_8_0_0_2, JAVA_31_0_0_8_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_31_0_0_8_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_8_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_31_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_31_0_0_8_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_31_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0_0, JAVA_31_0_0_1, JAVA_31_0_0_2, JAVA_31_0_0_3, JAVA_31_0_0_4, JAVA_31_0_0_5, JAVA_31_0_0_6, JAVA_31_0_0_7, JAVA_31_0_0_8);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_31_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_31_0_0);
	public final static Rule JAVA_31 = new Rule(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getNewConstructorCall(), JAVA_31_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_32_0_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_32_0_0_0_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getExplicitConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.EXPLICIT_CONSTRUCTOR_CALL__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_32_0_0_0_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_32_0_0_0_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getExplicitConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.EXPLICIT_CONSTRUCTOR_CALL__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_32_0_0_0_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_0_0_0_2_0_0_0, JAVA_32_0_0_0_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_32_0_0_0_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_0_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_32_0_0_0_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_32_0_0_0_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_32_0_0_0_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_32_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_0_0_0_0, JAVA_32_0_0_0_0_0_1, JAVA_32_0_0_0_0_0_2, JAVA_32_0_0_0_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_32_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_32_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_32_0_0_0_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_32_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getExplicitConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.EXPLICIT_CONSTRUCTOR_CALL__CALL_TARGET), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_32_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_32_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getExplicitConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.EXPLICIT_CONSTRUCTOR_CALL__ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_32_0_0_3_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_32_0_0_3_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getExplicitConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.EXPLICIT_CONSTRUCTOR_CALL__ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_32_0_0_3_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_3_0_0_1_0_0_0, JAVA_32_0_0_3_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_32_0_0_3_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_3_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_32_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_32_0_0_3_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_32_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_3_0_0_0, JAVA_32_0_0_3_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_32_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_32_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_32_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_32_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_32_0_0_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_32_0_0_5_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_32_0_0_5_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_32_0_0_5_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getExplicitConstructorCall().getEStructuralFeature(org.emftext.language.java.instantiations.InstantiationsPackage.EXPLICIT_CONSTRUCTOR_CALL__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_32_0_0_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_5_0_0_0, JAVA_32_0_0_5_0_0_1, JAVA_32_0_0_5_0_0_2, JAVA_32_0_0_5_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_32_0_0_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_5_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_32_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_32_0_0_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_32_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0_0, JAVA_32_0_0_1, JAVA_32_0_0_2, JAVA_32_0_0_3, JAVA_32_0_0_4, JAVA_32_0_0_5);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_32_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_32_0_0);
	public final static Rule JAVA_32 = new Rule(org.emftext.language.java.instantiations.InstantiationsPackage.eINSTANCE.getExplicitConstructorCall(), JAVA_32_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_33_0_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("new", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_33_0_0_0_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationByValues().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INSTANTIATION_BY_VALUES__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_33_0_0_0_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationByValues().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INSTANTIATION_BY_VALUES__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.PLUS, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_33_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_33_0_0_0_0_0_0, JAVA_33_0_0_0_0_0_1, JAVA_33_0_0_0_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_33_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_33_0_0_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_33_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_33_0_0_0_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_33_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationByValues().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INSTANTIATION_BY_VALUES__ARRAY_INITIALIZER), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_33_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationByValues().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INSTANTIATION_BY_VALUES__ARRAY_SELECTORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_33_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_33_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_33_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_33_0_0_3_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationByValues().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INSTANTIATION_BY_VALUES__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_33_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_33_0_0_3_0_0_0, JAVA_33_0_0_3_0_0_1, JAVA_33_0_0_3_0_0_2, JAVA_33_0_0_3_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_33_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_33_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_33_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_33_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_33_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_33_0_0_0, JAVA_33_0_0_1, JAVA_33_0_0_2, JAVA_33_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_33_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_33_0_0);
	public final static Rule JAVA_33 = new Rule(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationByValues(), JAVA_33_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_34_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("new", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_34_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationBySize().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INSTANTIATION_BY_SIZE__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_34_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("[", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_34_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationBySize().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INSTANTIATION_BY_SIZE__SIZES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_34_0_0_2_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("]", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_34_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_34_0_0_2_0_0_0, JAVA_34_0_0_2_0_0_1, JAVA_34_0_0_2_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_34_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_34_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_34_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_34_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.PLUS);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_34_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationBySize().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INSTANTIATION_BY_SIZE__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_34_0_0_4_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_34_0_0_4_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_34_0_0_4_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_34_0_0_4_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationBySize().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INSTANTIATION_BY_SIZE__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_34_0_0_4_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_34_0_0_4_0_0_0, JAVA_34_0_0_4_0_0_1, JAVA_34_0_0_4_0_0_2, JAVA_34_0_0_4_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_34_0_0_4_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_34_0_0_4_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_34_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_34_0_0_4_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_34_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_34_0_0_0, JAVA_34_0_0_1, JAVA_34_0_0_2, JAVA_34_0_0_3, JAVA_34_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_34_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_34_0_0);
	public final static Rule JAVA_34 = new Rule(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInstantiationBySize(), JAVA_34_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_35_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_35_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInitializer().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INITIALIZER__INITIAL_VALUES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_35_0_0_1_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_35_0_0_1_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInitializer().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_INITIALIZER__INITIAL_VALUES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_35_0_0_1_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_35_0_0_1_0_0_1_0_0_0, JAVA_35_0_0_1_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_35_0_0_1_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_35_0_0_1_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_35_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_35_0_0_1_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_35_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_35_0_0_1_0_0_0, JAVA_35_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_35_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_35_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_35_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_35_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_35_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_35_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_35_0_0_2_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_35_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_35_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_35_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_35_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_35_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_35_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_35_0_0_0, JAVA_35_0_0_1, JAVA_35_0_0_2, JAVA_35_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_35_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_35_0_0);
	public final static Rule JAVA_35 = new Rule(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayInitializer(), JAVA_35_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_36_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("[", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_36_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArraySelector().getEStructuralFeature(org.emftext.language.java.arrays.ArraysPackage.ARRAY_SELECTOR__POSITION), org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_36_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("]", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_36_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_36_0_0_0, JAVA_36_0_0_1, JAVA_36_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_36_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_36_0_0);
	public final static Rule JAVA_36 = new Rule(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArraySelector(), JAVA_36_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_37_0_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.types.TypesPackage.eINSTANCE.getNamespaceClassifierReference().getEStructuralFeature(org.emftext.language.java.types.TypesPackage.NAMESPACE_CLASSIFIER_REFERENCE__NAMESPACES), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_37_0_0_0_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_37_0_0_0_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_37_0_0_0_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_37_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_37_0_0_0_0_0_0, JAVA_37_0_0_0_0_0_1, JAVA_37_0_0_0_0_0_2, JAVA_37_0_0_0_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_37_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_37_0_0_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_37_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_37_0_0_0_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_37_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.types.TypesPackage.eINSTANCE.getNamespaceClassifierReference().getEStructuralFeature(org.emftext.language.java.types.TypesPackage.NAMESPACE_CLASSIFIER_REFERENCE__CLASSIFIER_REFERENCES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_37_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_37_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_37_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_37_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_37_0_0_1_0_0_0, JAVA_37_0_0_1_0_0_1, JAVA_37_0_0_1_0_0_2, JAVA_37_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_37_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_37_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_37_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_37_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_37_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.types.TypesPackage.eINSTANCE.getNamespaceClassifierReference().getEStructuralFeature(org.emftext.language.java.types.TypesPackage.NAMESPACE_CLASSIFIER_REFERENCE__CLASSIFIER_REFERENCES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_37_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_37_0_0_0, JAVA_37_0_0_1, JAVA_37_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_37_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_37_0_0);
	public final static Rule JAVA_37 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getNamespaceClassifierReference(), JAVA_37_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_38_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.types.TypesPackage.eINSTANCE.getClassifierReference().getEStructuralFeature(org.emftext.language.java.types.TypesPackage.CLASSIFIER_REFERENCE__TARGET), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_38_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_38_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.types.TypesPackage.eINSTANCE.getClassifierReference().getEStructuralFeature(org.emftext.language.java.types.TypesPackage.CLASSIFIER_REFERENCE__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_38_0_0_1_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_38_0_0_1_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.types.TypesPackage.eINSTANCE.getClassifierReference().getEStructuralFeature(org.emftext.language.java.types.TypesPackage.CLASSIFIER_REFERENCE__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_38_0_0_1_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_38_0_0_1_0_0_2_0_0_0, JAVA_38_0_0_1_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_38_0_0_1_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_38_0_0_1_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_38_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_38_0_0_1_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_38_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_38_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_38_0_0_1_0_0_0, JAVA_38_0_0_1_0_0_1, JAVA_38_0_0_1_0_0_2, JAVA_38_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_38_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_38_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_38_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_38_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_38_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_38_0_0_0, JAVA_38_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_38_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_38_0_0);
	public final static Rule JAVA_38 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getClassifierReference(), JAVA_38_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_39_0_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_39_0_0_0_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getMethodCall().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.METHOD_CALL__CALL_TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_39_0_0_0_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_39_0_0_0_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getMethodCall().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.METHOD_CALL__CALL_TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_39_0_0_0_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_0_0_0_2_0_0_0, JAVA_39_0_0_0_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_39_0_0_0_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_0_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_39_0_0_0_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_39_0_0_0_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_39_0_0_0_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_39_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_0_0_0_0, JAVA_39_0_0_0_0_0_1, JAVA_39_0_0_0_0_0_2, JAVA_39_0_0_0_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_39_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_39_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_39_0_0_0_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_39_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getMethodCall().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.METHOD_CALL__TARGET), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_39_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_39_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getMethodCall().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.METHOD_CALL__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_39_0_0_2_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_39_0_0_2_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getMethodCall().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.METHOD_CALL__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_39_0_0_2_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_2_0_0_2_0_0_0, JAVA_39_0_0_2_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_39_0_0_2_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_2_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_39_0_0_2_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_39_0_0_2_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_39_0_0_2_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_39_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_2_0_0_0, JAVA_39_0_0_2_0_0_1, JAVA_39_0_0_2_0_0_2, JAVA_39_0_0_2_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_39_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_39_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_39_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_39_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_39_0_0_4_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getMethodCall().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.METHOD_CALL__ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_39_0_0_4_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_39_0_0_4_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getMethodCall().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.METHOD_CALL__ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_39_0_0_4_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_4_0_0_1_0_0_0, JAVA_39_0_0_4_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_39_0_0_4_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_4_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_39_0_0_4_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_39_0_0_4_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_39_0_0_4_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_4_0_0_0, JAVA_39_0_0_4_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_39_0_0_4_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_4_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_39_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_39_0_0_4_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_39_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_39_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getMethodCall().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.METHOD_CALL__ARRAY_SELECTORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_39_0_0_7_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_39_0_0_7_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_39_0_0_7_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_39_0_0_7_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getMethodCall().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.METHOD_CALL__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_39_0_0_7_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_7_0_0_0, JAVA_39_0_0_7_0_0_1, JAVA_39_0_0_7_0_0_2, JAVA_39_0_0_7_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_39_0_0_7_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_7_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_39_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_39_0_0_7_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_39_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0_0, JAVA_39_0_0_1, JAVA_39_0_0_2, JAVA_39_0_0_3, JAVA_39_0_0_4, JAVA_39_0_0_5, JAVA_39_0_0_6, JAVA_39_0_0_7);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_39_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_39_0_0);
	public final static Rule JAVA_39 = new Rule(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getMethodCall(), JAVA_39_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_40_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getIdentifierReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.IDENTIFIER_REFERENCE__TARGET), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_40_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_40_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getIdentifierReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.IDENTIFIER_REFERENCE__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_40_0_0_1_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_40_0_0_1_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getIdentifierReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.IDENTIFIER_REFERENCE__TYPE_ARGUMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_40_0_0_1_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_40_0_0_1_0_0_2_0_0_0, JAVA_40_0_0_1_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_40_0_0_1_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_40_0_0_1_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_40_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_40_0_0_1_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_40_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_40_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_40_0_0_1_0_0_0, JAVA_40_0_0_1_0_0_1, JAVA_40_0_0_1_0_0_2, JAVA_40_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_40_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_40_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_40_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_40_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_40_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getIdentifierReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.IDENTIFIER_REFERENCE__ARRAY_SELECTORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_40_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_40_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_40_0_0_3_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_40_0_0_3_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getIdentifierReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.IDENTIFIER_REFERENCE__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_40_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_40_0_0_3_0_0_0, JAVA_40_0_0_3_0_0_1, JAVA_40_0_0_3_0_0_2, JAVA_40_0_0_3_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_40_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_40_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_40_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_40_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_40_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_40_0_0_0, JAVA_40_0_0_1, JAVA_40_0_0_2, JAVA_40_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_40_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_40_0_0);
	public final static Rule JAVA_40 = new Rule(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getIdentifierReference(), JAVA_40_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_41_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("class", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_41_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_41_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_41_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_41_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getReflectiveClassReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.REFLECTIVE_CLASS_REFERENCE__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_41_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_41_0_0_1_0_0_0, JAVA_41_0_0_1_0_0_1, JAVA_41_0_0_1_0_0_2, JAVA_41_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_41_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_41_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_41_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_41_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_41_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_41_0_0_0, JAVA_41_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_41_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_41_0_0);
	public final static Rule JAVA_41 = new Rule(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getReflectiveClassReference(), JAVA_41_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_42_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getSelfReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.SELF_REFERENCE__SELF), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_42_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_42_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_42_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_42_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getSelfReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.SELF_REFERENCE__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_42_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_42_0_0_1_0_0_0, JAVA_42_0_0_1_0_0_1, JAVA_42_0_0_1_0_0_2, JAVA_42_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_42_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_42_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_42_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_42_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_42_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_42_0_0_0, JAVA_42_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_42_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_42_0_0);
	public final static Rule JAVA_42 = new Rule(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getSelfReference(), JAVA_42_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_43_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getPrimitiveTypeReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.PRIMITIVE_TYPE_REFERENCE__PRIMITIVE_TYPE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_43_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getPrimitiveTypeReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.PRIMITIVE_TYPE_REFERENCE__ARRAY_SELECTORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_43_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_43_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_43_0_0_2_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_43_0_0_2_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getPrimitiveTypeReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.PRIMITIVE_TYPE_REFERENCE__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_43_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_43_0_0_2_0_0_0, JAVA_43_0_0_2_0_0_1, JAVA_43_0_0_2_0_0_2, JAVA_43_0_0_2_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_43_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_43_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_43_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_43_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_43_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_43_0_0_0, JAVA_43_0_0_1, JAVA_43_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_43_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_43_0_0);
	public final static Rule JAVA_43 = new Rule(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getPrimitiveTypeReference(), JAVA_43_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_44_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("this", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_44_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_44_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_44_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_44_0_0);
	public final static Rule JAVA_44 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getThis(), JAVA_44_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_45_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("super", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_45_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_45_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_45_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_45_0_0);
	public final static Rule JAVA_45 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getSuper(), JAVA_45_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_46_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getStringReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.STRING_REFERENCE__VALUE), "STRING_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_46_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_46_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_46_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_46_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getStringReference().getEStructuralFeature(org.emftext.language.java.references.ReferencesPackage.STRING_REFERENCE__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_46_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_46_0_0_1_0_0_0, JAVA_46_0_0_1_0_0_1, JAVA_46_0_0_1_0_0_2, JAVA_46_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_46_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_46_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_46_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_46_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_46_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_46_0_0_0, JAVA_46_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_46_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_46_0_0);
	public final static Rule JAVA_46 = new Rule(org.emftext.language.java.references.ReferencesPackage.eINSTANCE.getStringReference(), JAVA_46_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_47_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getQualifiedTypeArgument().getEStructuralFeature(org.emftext.language.java.generics.GenericsPackage.QUALIFIED_TYPE_ARGUMENT__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_47_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getQualifiedTypeArgument().getEStructuralFeature(org.emftext.language.java.generics.GenericsPackage.QUALIFIED_TYPE_ARGUMENT__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_47_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_47_0_0_0, JAVA_47_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_47_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_47_0_0);
	public final static Rule JAVA_47 = new Rule(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getQualifiedTypeArgument(), JAVA_47_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_48_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("?", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_48_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_48_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_48_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_48_0_0);
	public final static Rule JAVA_48 = new Rule(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getUnknownTypeArgument(), JAVA_48_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_49_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("?", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_49_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("extends", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_49_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getExtendsTypeArgument().getEStructuralFeature(org.emftext.language.java.generics.GenericsPackage.EXTENDS_TYPE_ARGUMENT__EXTEND_TYPES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_49_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("&", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_49_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getExtendsTypeArgument().getEStructuralFeature(org.emftext.language.java.generics.GenericsPackage.EXTENDS_TYPE_ARGUMENT__EXTEND_TYPES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_49_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_49_0_0_3_0_0_0, JAVA_49_0_0_3_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_49_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_49_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_49_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_49_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_49_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getExtendsTypeArgument().getEStructuralFeature(org.emftext.language.java.generics.GenericsPackage.EXTENDS_TYPE_ARGUMENT__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_49_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_49_0_0_0, JAVA_49_0_0_1, JAVA_49_0_0_2, JAVA_49_0_0_3, JAVA_49_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_49_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_49_0_0);
	public final static Rule JAVA_49 = new Rule(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getExtendsTypeArgument(), JAVA_49_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_50_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("?", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_50_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("super", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_50_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getSuperTypeArgument().getEStructuralFeature(org.emftext.language.java.generics.GenericsPackage.SUPER_TYPE_ARGUMENT__SUPER_TYPE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_50_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getSuperTypeArgument().getEStructuralFeature(org.emftext.language.java.generics.GenericsPackage.SUPER_TYPE_ARGUMENT__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_50_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_50_0_0_0, JAVA_50_0_0_1, JAVA_50_0_0_2, JAVA_50_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_50_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_50_0_0);
	public final static Rule JAVA_50 = new Rule(org.emftext.language.java.generics.GenericsPackage.eINSTANCE.getSuperTypeArgument(), JAVA_50_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_51_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("assert", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_51_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getAssert().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.ASSERT__CONDITION), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_51_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(":", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_51_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getAssert().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.ASSERT__ERROR_MESSAGE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_51_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_51_0_0_2_0_0_0, JAVA_51_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_51_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_51_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_51_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_51_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_51_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_51_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_51_0_0_0, JAVA_51_0_0_1, JAVA_51_0_0_2, JAVA_51_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_51_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_51_0_0);
	public final static Rule JAVA_51 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getAssert(), JAVA_51_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_52_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("if", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_52_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_52_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getCondition().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.CONDITION__CONDITION), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_52_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_52_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getCondition().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.CONDITION__STATEMENT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_52_0_0_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("else", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_52_0_0_5_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getCondition().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.CONDITION__ELSE_STATEMENT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_52_0_0_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_52_0_0_5_0_0_0, JAVA_52_0_0_5_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_52_0_0_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_52_0_0_5_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_52_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_52_0_0_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_52_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_52_0_0_0, JAVA_52_0_0_1, JAVA_52_0_0_2, JAVA_52_0_0_3, JAVA_52_0_0_4, JAVA_52_0_0_5);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_52_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_52_0_0);
	public final static Rule JAVA_52 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getCondition(), JAVA_52_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_53_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("for", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_53_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_53_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getForLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.FOR_LOOP__INIT), org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_53_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_53_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getForLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.FOR_LOOP__CONDITION), org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_53_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_53_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getForLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.FOR_LOOP__UPDATES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_53_0_0_6_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_53_0_0_6_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getForLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.FOR_LOOP__UPDATES), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_53_0_0_6_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_53_0_0_6_0_0_1_0_0_0, JAVA_53_0_0_6_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_53_0_0_6_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_53_0_0_6_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_53_0_0_6_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_53_0_0_6_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_53_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_53_0_0_6_0_0_0, JAVA_53_0_0_6_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_53_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_53_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_53_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_53_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_53_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_53_0_0_8 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getForLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.FOR_LOOP__STATEMENT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_53_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_53_0_0_0, JAVA_53_0_0_1, JAVA_53_0_0_2, JAVA_53_0_0_3, JAVA_53_0_0_4, JAVA_53_0_0_5, JAVA_53_0_0_6, JAVA_53_0_0_7, JAVA_53_0_0_8);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_53_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_53_0_0);
	public final static Rule JAVA_53 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getForLoop(), JAVA_53_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_54_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("for", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_54_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_54_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getForEachLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.FOR_EACH_LOOP__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_54_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(":", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_54_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getForEachLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.FOR_EACH_LOOP__COLLECTION), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_54_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_54_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getForEachLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.FOR_EACH_LOOP__STATEMENT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_54_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_54_0_0_0, JAVA_54_0_0_1, JAVA_54_0_0_2, JAVA_54_0_0_3, JAVA_54_0_0_4, JAVA_54_0_0_5, JAVA_54_0_0_6);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_54_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_54_0_0);
	public final static Rule JAVA_54 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getForEachLoop(), JAVA_54_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_55_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("while", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_55_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_55_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getWhileLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.WHILE_LOOP__CONDITION), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_55_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_55_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getWhileLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.WHILE_LOOP__STATEMENT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_55_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_55_0_0_0, JAVA_55_0_0_1, JAVA_55_0_0_2, JAVA_55_0_0_3, JAVA_55_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_55_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_55_0_0);
	public final static Rule JAVA_55 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getWhileLoop(), JAVA_55_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_56_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("do", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_56_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getDoWhileLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.DO_WHILE_LOOP__STATEMENT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_56_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("while", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_56_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_56_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getDoWhileLoop().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.DO_WHILE_LOOP__CONDITION), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_56_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_56_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_56_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_56_0_0_0, JAVA_56_0_0_1, JAVA_56_0_0_2, JAVA_56_0_0_3, JAVA_56_0_0_4, JAVA_56_0_0_5, JAVA_56_0_0_6);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_56_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_56_0_0);
	public final static Rule JAVA_56 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getDoWhileLoop(), JAVA_56_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_57_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_57_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_57_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_57_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_57_0_0);
	public final static Rule JAVA_57 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getEmptyStatement(), JAVA_57_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_58_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("synchronized", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_58_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_58_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getSynchronizedBlock().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.SYNCHRONIZED_BLOCK__LOCK_PROVIDER), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_58_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_58_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_58_0_0_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_58_0_0_5_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getSynchronizedBlock().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.SYNCHRONIZED_BLOCK__STATEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_58_0_0_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_58_0_0_5_0_0_0, JAVA_58_0_0_5_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_58_0_0_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_58_0_0_5_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_58_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_58_0_0_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_58_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_58_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_58_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_58_0_0_0, JAVA_58_0_0_1, JAVA_58_0_0_2, JAVA_58_0_0_3, JAVA_58_0_0_4, JAVA_58_0_0_5, JAVA_58_0_0_6, JAVA_58_0_0_7);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_58_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_58_0_0);
	public final static Rule JAVA_58 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getSynchronizedBlock(), JAVA_58_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_59_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("try", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_59_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_59_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_59_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getTryBlock().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.TRY_BLOCK__STATEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_59_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_59_0_0_2_0_0_0, JAVA_59_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_59_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_59_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_59_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_59_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_59_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_59_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_59_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getTryBlock().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.TRY_BLOCK__CATCHE_BLOCKS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_59_0_0_6_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("finally", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_59_0_0_6_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getTryBlock().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.TRY_BLOCK__FINALLY_BLOCK), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_59_0_0_6_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_59_0_0_6_0_0_0, JAVA_59_0_0_6_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_59_0_0_6_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_59_0_0_6_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_59_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_59_0_0_6_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_59_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_59_0_0_0, JAVA_59_0_0_1, JAVA_59_0_0_2, JAVA_59_0_0_3, JAVA_59_0_0_4, JAVA_59_0_0_5, JAVA_59_0_0_6);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_59_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_59_0_0);
	public final static Rule JAVA_59 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getTryBlock(), JAVA_59_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_60_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("catch", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_60_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_60_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getCatchBlock().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.CATCH_BLOCK__PARAMETER), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_60_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_60_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_60_0_0_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_60_0_0_5_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getCatchBlock().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.CATCH_BLOCK__STATEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_60_0_0_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_60_0_0_5_0_0_0, JAVA_60_0_0_5_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_60_0_0_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_60_0_0_5_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_60_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_60_0_0_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_60_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_60_0_0_7 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_60_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_60_0_0_0, JAVA_60_0_0_1, JAVA_60_0_0_2, JAVA_60_0_0_3, JAVA_60_0_0_4, JAVA_60_0_0_5, JAVA_60_0_0_6, JAVA_60_0_0_7);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_60_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_60_0_0);
	public final static Rule JAVA_60 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getCatchBlock(), JAVA_60_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_61_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("switch", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_61_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_61_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getSwitch().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.SWITCH__VARIABLE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_61_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_61_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("{", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_61_0_0_5_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getSwitch().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.SWITCH__CASES), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_61_0_0_5_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_61_0_0_5_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_61_0_0_5_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_61_0_0_5_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_61_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_61_0_0_5_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_61_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("}", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_61_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_61_0_0_0, JAVA_61_0_0_1, JAVA_61_0_0_2, JAVA_61_0_0_3, JAVA_61_0_0_4, JAVA_61_0_0_5, JAVA_61_0_0_6);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_61_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_61_0_0);
	public final static Rule JAVA_61 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getSwitch(), JAVA_61_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_62_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("case", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_62_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getNormalSwitchCase().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.NORMAL_SWITCH_CASE__CONDITION), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_62_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(":", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_62_0_0_3_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_62_0_0_3_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getNormalSwitchCase().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.NORMAL_SWITCH_CASE__STATEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_62_0_0_3_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_62_0_0_3_0_0_0, JAVA_62_0_0_3_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_62_0_0_3_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_62_0_0_3_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_62_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_62_0_0_3_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_62_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_62_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_62_0_0_0, JAVA_62_0_0_1, JAVA_62_0_0_2, JAVA_62_0_0_3, JAVA_62_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_62_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_62_0_0);
	public final static Rule JAVA_62 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getNormalSwitchCase(), JAVA_62_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_63_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("default", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_63_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(":", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_63_0_0_2_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 1);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_63_0_0_2_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getDefaultSwitchCase().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.DEFAULT_SWITCH_CASE__STATEMENTS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_63_0_0_2_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_63_0_0_2_0_0_0, JAVA_63_0_0_2_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_63_0_0_2_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_63_0_0_2_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_63_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_63_0_0_2_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaLineBreak JAVA_63_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaLineBreak(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_63_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_63_0_0_0, JAVA_63_0_0_1, JAVA_63_0_0_2, JAVA_63_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_63_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_63_0_0);
	public final static Rule JAVA_63 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getDefaultSwitchCase(), JAVA_63_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_64_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("return", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_64_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getReturn().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.RETURN__RETURN_VALUE), org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_64_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_64_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_64_0_0_0, JAVA_64_0_0_1, JAVA_64_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_64_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_64_0_0);
	public final static Rule JAVA_64 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getReturn(), JAVA_64_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_65_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("throw", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_65_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getThrow().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.THROW__THROWABLE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_65_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_65_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_65_0_0_0, JAVA_65_0_0_1, JAVA_65_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_65_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_65_0_0);
	public final static Rule JAVA_65 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getThrow(), JAVA_65_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_66_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("break", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_66_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getBreak().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.BREAK__TARGET), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_66_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_66_0_0_1_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_66_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_66_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_66_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_66_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_66_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_66_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_66_0_0_0, JAVA_66_0_0_1, JAVA_66_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_66_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_66_0_0);
	public final static Rule JAVA_66 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getBreak(), JAVA_66_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_67_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("continue", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_67_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getContinue().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.CONTINUE__TARGET), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_67_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_67_0_0_1_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_67_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_67_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_67_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_67_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_67_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_67_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_67_0_0_0, JAVA_67_0_0_1, JAVA_67_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_67_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_67_0_0);
	public final static Rule JAVA_67 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getContinue(), JAVA_67_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_68_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getJumpLabel().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.JUMP_LABEL__NAME), "IDENTIFIER", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_68_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(":", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_68_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getJumpLabel().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.JUMP_LABEL__STATEMENT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_68_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_68_0_0_0, JAVA_68_0_0_1, JAVA_68_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_68_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_68_0_0);
	public final static Rule JAVA_68 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getJumpLabel(), JAVA_68_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_69_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getExpressionStatement().getEStructuralFeature(org.emftext.language.java.statements.StatementsPackage.EXPRESSION_STATEMENT__EXPRESSION), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_69_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(";", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_69_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_69_0_0_0, JAVA_69_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_69_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_69_0_0);
	public final static Rule JAVA_69 = new Rule(org.emftext.language.java.statements.StatementsPackage.eINSTANCE.getExpressionStatement(), JAVA_69_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_70_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getExpressionList().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.EXPRESSION_LIST__EXPRESSIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_70_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(",", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_70_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getExpressionList().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.EXPRESSION_LIST__EXPRESSIONS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_70_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_70_0_0_1_0_0_0, JAVA_70_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_70_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_70_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_70_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_70_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_70_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_70_0_0_0, JAVA_70_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_70_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_70_0_0);
	public final static Rule JAVA_70 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getExpressionList(), JAVA_70_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_71_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAssignmentExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.ASSIGNMENT_EXPRESSION__CHILD), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_71_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAssignmentExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.ASSIGNMENT_EXPRESSION__ASSIGNMENT_OPERATOR), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_71_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAssignmentExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.ASSIGNMENT_EXPRESSION__VALUE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_71_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_71_0_0_1_0_0_0, JAVA_71_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_71_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_71_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_71_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_71_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_71_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_71_0_0_0, JAVA_71_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_71_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_71_0_0);
	public final static Rule JAVA_71 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAssignmentExpression(), JAVA_71_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_72_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getConditionalExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.CONDITIONAL_EXPRESSION__CHILD), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_72_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("?", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_72_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getConditionalExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.CONDITIONAL_EXPRESSION__EXPRESSION_IF), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_72_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(":", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_72_0_0_1_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getConditionalExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.CONDITIONAL_EXPRESSION__EXPRESSION_ELSE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_72_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_72_0_0_1_0_0_0, JAVA_72_0_0_1_0_0_1, JAVA_72_0_0_1_0_0_2, JAVA_72_0_0_1_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_72_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_72_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_72_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_72_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_72_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_72_0_0_0, JAVA_72_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_72_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_72_0_0);
	public final static Rule JAVA_72 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getConditionalExpression(), JAVA_72_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_73_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getConditionalOrExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.CONDITIONAL_OR_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_73_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("||", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_73_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getConditionalOrExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.CONDITIONAL_OR_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_73_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_73_0_0_1_0_0_0, JAVA_73_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_73_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_73_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_73_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_73_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_73_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_73_0_0_0, JAVA_73_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_73_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_73_0_0);
	public final static Rule JAVA_73 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getConditionalOrExpression(), JAVA_73_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_74_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getConditionalAndExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.CONDITIONAL_AND_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_74_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("&&", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_74_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getConditionalAndExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.CONDITIONAL_AND_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_74_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_74_0_0_1_0_0_0, JAVA_74_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_74_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_74_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_74_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_74_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_74_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_74_0_0_0, JAVA_74_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_74_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_74_0_0);
	public final static Rule JAVA_74 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getConditionalAndExpression(), JAVA_74_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_75_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getInclusiveOrExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.INCLUSIVE_OR_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_75_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("|", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_75_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getInclusiveOrExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.INCLUSIVE_OR_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_75_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_75_0_0_1_0_0_0, JAVA_75_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_75_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_75_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_75_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_75_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_75_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_75_0_0_0, JAVA_75_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_75_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_75_0_0);
	public final static Rule JAVA_75 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getInclusiveOrExpression(), JAVA_75_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_76_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getExclusiveOrExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.EXCLUSIVE_OR_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_76_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("^", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_76_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getExclusiveOrExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.EXCLUSIVE_OR_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_76_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_76_0_0_1_0_0_0, JAVA_76_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_76_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_76_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_76_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_76_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_76_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_76_0_0_0, JAVA_76_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_76_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_76_0_0);
	public final static Rule JAVA_76 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getExclusiveOrExpression(), JAVA_76_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_77_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAndExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.AND_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_77_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("&", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_77_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAndExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.AND_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_77_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_77_0_0_1_0_0_0, JAVA_77_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_77_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_77_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_77_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_77_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_77_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_77_0_0_0, JAVA_77_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_77_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_77_0_0);
	public final static Rule JAVA_77 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAndExpression(), JAVA_77_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_78_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getEqualityExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.EQUALITY_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_78_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getEqualityExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.EQUALITY_EXPRESSION__EQUALITY_OPERATORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_78_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getEqualityExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.EQUALITY_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_78_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_78_0_0_1_0_0_0, JAVA_78_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_78_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_78_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_78_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_78_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_78_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_78_0_0_0, JAVA_78_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_78_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_78_0_0);
	public final static Rule JAVA_78 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getEqualityExpression(), JAVA_78_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_79_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getInstanceOfExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.INSTANCE_OF_EXPRESSION__CHILD), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_79_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("instanceof", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_79_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getInstanceOfExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.INSTANCE_OF_EXPRESSION__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_79_0_0_1_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getInstanceOfExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.INSTANCE_OF_EXPRESSION__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_79_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_79_0_0_1_0_0_0, JAVA_79_0_0_1_0_0_1, JAVA_79_0_0_1_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_79_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_79_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_79_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_79_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_79_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_79_0_0_0, JAVA_79_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_79_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_79_0_0);
	public final static Rule JAVA_79 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getInstanceOfExpression(), JAVA_79_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_80_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getRelationExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.RELATION_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_80_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getRelationExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.RELATION_EXPRESSION__RELATION_OPERATORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_80_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getRelationExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.RELATION_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_80_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_80_0_0_1_0_0_0, JAVA_80_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_80_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_80_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_80_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_80_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_80_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_80_0_0_0, JAVA_80_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_80_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_80_0_0);
	public final static Rule JAVA_80 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getRelationExpression(), JAVA_80_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_81_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getShiftExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.SHIFT_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_81_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getShiftExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.SHIFT_EXPRESSION__SHIFT_OPERATORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_81_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getShiftExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.SHIFT_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_81_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_81_0_0_1_0_0_0, JAVA_81_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_81_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_81_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_81_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_81_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_81_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_81_0_0_0, JAVA_81_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_81_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_81_0_0);
	public final static Rule JAVA_81 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getShiftExpression(), JAVA_81_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_82_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAdditiveExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.ADDITIVE_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_82_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAdditiveExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.ADDITIVE_EXPRESSION__ADDITIVE_OPERATORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_82_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAdditiveExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.ADDITIVE_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_82_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_82_0_0_1_0_0_0, JAVA_82_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_82_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_82_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_82_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_82_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_82_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_82_0_0_0, JAVA_82_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_82_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_82_0_0);
	public final static Rule JAVA_82 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getAdditiveExpression(), JAVA_82_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_83_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getMultiplicativeExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.MULTIPLICATIVE_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_83_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getMultiplicativeExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.MULTIPLICATIVE_EXPRESSION__MULTIPLICATIVE_OPERATORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_83_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getMultiplicativeExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.MULTIPLICATIVE_EXPRESSION__CHILDREN), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_83_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_83_0_0_1_0_0_0, JAVA_83_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_83_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_83_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_83_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_83_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_83_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_83_0_0_0, JAVA_83_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_83_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_83_0_0);
	public final static Rule JAVA_83 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getMultiplicativeExpression(), JAVA_83_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_84_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getUnaryExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.UNARY_EXPRESSION__OPERATORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_84_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_84_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getUnaryExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.UNARY_EXPRESSION__CHILD), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_84_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_84_0_0_0, JAVA_84_0_0_1, JAVA_84_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_84_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_84_0_0);
	public final static Rule JAVA_84 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getUnaryExpression(), JAVA_84_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_85_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getSuffixUnaryModificationExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.SUFFIX_UNARY_MODIFICATION_EXPRESSION__CHILD), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_85_0_0_1_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_85_0_0_1_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getSuffixUnaryModificationExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.SUFFIX_UNARY_MODIFICATION_EXPRESSION__OPERATOR), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_85_0_0_1_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_85_0_0_1_0_0_0, JAVA_85_0_0_1_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_85_0_0_1_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_85_0_0_1_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_85_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_85_0_0_1_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_85_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_85_0_0_0, JAVA_85_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_85_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_85_0_0);
	public final static Rule JAVA_85 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getSuffixUnaryModificationExpression(), JAVA_85_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_86_0_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getPrefixUnaryModificationExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.PREFIX_UNARY_MODIFICATION_EXPRESSION__OPERATOR), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_86_0_0_0_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_86_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_86_0_0_0_0_0_0, JAVA_86_0_0_0_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_86_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_86_0_0_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_86_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_86_0_0_0_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_86_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getPrefixUnaryModificationExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.PREFIX_UNARY_MODIFICATION_EXPRESSION__CHILD), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_86_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_86_0_0_0, JAVA_86_0_0_1);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_86_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_86_0_0);
	public final static Rule JAVA_86 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getPrefixUnaryModificationExpression(), JAVA_86_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_87_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_87_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getCastExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.CAST_EXPRESSION__TYPE_REFERENCE), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_87_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getCastExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.CAST_EXPRESSION__ARRAY_DIMENSIONS_BEFORE), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_87_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_87_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getCastExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.CAST_EXPRESSION__CHILD), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_87_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_87_0_0_0, JAVA_87_0_0_1, JAVA_87_0_0_2, JAVA_87_0_0_3, JAVA_87_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_87_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_87_0_0);
	public final static Rule JAVA_87 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getCastExpression(), JAVA_87_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_88_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("(", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_88_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getNestedExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.NESTED_EXPRESSION__EXPRESSION), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_88_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(")", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_88_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getNestedExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.NESTED_EXPRESSION__ARRAY_SELECTORS), org.emftext.language.java.resource.java.grammar.JavaCardinality.STAR, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_88_0_0_4_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_88_0_0_4_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(".", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_88_0_0_4_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaContainment JAVA_88_0_0_4_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaContainment(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getNestedExpression().getEStructuralFeature(org.emftext.language.java.expressions.ExpressionsPackage.NESTED_EXPRESSION__NEXT), org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_88_0_0_4_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_88_0_0_4_0_0_0, JAVA_88_0_0_4_0_0_1, JAVA_88_0_0_4_0_0_2, JAVA_88_0_0_4_0_0_3);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_88_0_0_4_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_88_0_0_4_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_88_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_88_0_0_4_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.QUESTIONMARK);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_88_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_88_0_0_0, JAVA_88_0_0_1, JAVA_88_0_0_2, JAVA_88_0_0_3, JAVA_88_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_88_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_88_0_0);
	public final static Rule JAVA_88 = new Rule(org.emftext.language.java.expressions.ExpressionsPackage.eINSTANCE.getNestedExpression(), JAVA_88_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_89_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_89_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_89_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_89_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_89_0_0);
	public final static Rule JAVA_89 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignment(), JAVA_89_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_90_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("+=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_90_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_90_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_90_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_90_0_0);
	public final static Rule JAVA_90 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentPlus(), JAVA_90_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_91_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("-=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_91_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_91_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_91_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_91_0_0);
	public final static Rule JAVA_91 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentMinus(), JAVA_91_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_92_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("*=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_92_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_92_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_92_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_92_0_0);
	public final static Rule JAVA_92 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentMultiplication(), JAVA_92_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_93_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("/=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_93_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_93_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_93_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_93_0_0);
	public final static Rule JAVA_93 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentDivision(), JAVA_93_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_94_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("&=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_94_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_94_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_94_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_94_0_0);
	public final static Rule JAVA_94 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentAnd(), JAVA_94_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_95_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("|=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_95_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_95_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_95_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_95_0_0);
	public final static Rule JAVA_95 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentOr(), JAVA_95_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_96_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("^=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_96_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_96_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_96_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_96_0_0);
	public final static Rule JAVA_96 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentExclusiveOr(), JAVA_96_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_97_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("%=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_97_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_97_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_97_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_97_0_0);
	public final static Rule JAVA_97 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentModulo(), JAVA_97_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_98_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_98_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_98_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_98_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_98_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_98_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_98_0_0_0, JAVA_98_0_0_1, JAVA_98_0_0_2, JAVA_98_0_0_3, JAVA_98_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_98_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_98_0_0);
	public final static Rule JAVA_98 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentLeftShift(), JAVA_98_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_99_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_99_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_99_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_99_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_99_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_99_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_99_0_0_0, JAVA_99_0_0_1, JAVA_99_0_0_2, JAVA_99_0_0_3, JAVA_99_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_99_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_99_0_0);
	public final static Rule JAVA_99 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentRightShift(), JAVA_99_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_100_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_100_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_100_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_100_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_100_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_100_0_0_5 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_100_0_0_6 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_100_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_100_0_0_0, JAVA_100_0_0_1, JAVA_100_0_0_2, JAVA_100_0_0_3, JAVA_100_0_0_4, JAVA_100_0_0_5, JAVA_100_0_0_6);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_100_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_100_0_0);
	public final static Rule JAVA_100 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAssignmentUnsignedRightShift(), JAVA_100_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_101_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("+", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_101_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_101_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_101_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_101_0_0);
	public final static Rule JAVA_101 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getAddition(), JAVA_101_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_102_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("-", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_102_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_102_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_102_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_102_0_0);
	public final static Rule JAVA_102 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getSubtraction(), JAVA_102_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_103_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("*", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_103_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_103_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_103_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_103_0_0);
	public final static Rule JAVA_103 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getMultiplication(), JAVA_103_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_104_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("/", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_104_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_104_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_104_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_104_0_0);
	public final static Rule JAVA_104 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getDivision(), JAVA_104_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_105_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("%", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_105_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_105_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_105_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_105_0_0);
	public final static Rule JAVA_105 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getRemainder(), JAVA_105_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_106_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_106_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_106_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_106_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_106_0_0);
	public final static Rule JAVA_106 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getLessThan(), JAVA_106_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_107_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_107_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_107_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_107_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_107_0_0_0, JAVA_107_0_0_1, JAVA_107_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_107_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_107_0_0);
	public final static Rule JAVA_107 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getLessThanOrEqual(), JAVA_107_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_108_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_108_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_108_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_108_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_108_0_0);
	public final static Rule JAVA_108 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getGreaterThan(), JAVA_108_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_109_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_109_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_109_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_109_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_109_0_0_0, JAVA_109_0_0_1, JAVA_109_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_109_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_109_0_0);
	public final static Rule JAVA_109 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getGreaterThanOrEqual(), JAVA_109_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_110_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_110_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_110_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("<", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_110_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_110_0_0_0, JAVA_110_0_0_1, JAVA_110_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_110_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_110_0_0);
	public final static Rule JAVA_110 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getLeftShift(), JAVA_110_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_111_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_111_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_111_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_111_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_111_0_0_0, JAVA_111_0_0_1, JAVA_111_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_111_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_111_0_0);
	public final static Rule JAVA_111 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getRightShift(), JAVA_111_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_112_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_112_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_112_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_112_0_0_3 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_112_0_0_4 = new org.emftext.language.java.resource.java.grammar.JavaKeyword(">", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_112_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_112_0_0_0, JAVA_112_0_0_1, JAVA_112_0_0_2, JAVA_112_0_0_3, JAVA_112_0_0_4);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_112_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_112_0_0);
	public final static Rule JAVA_112 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getUnsignedRightShift(), JAVA_112_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_113_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("==", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_113_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_113_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_113_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_113_0_0);
	public final static Rule JAVA_113 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getEqual(), JAVA_113_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_114_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("!=", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_114_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_114_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_114_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_114_0_0);
	public final static Rule JAVA_114 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getNotEqual(), JAVA_114_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_115_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("++", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_115_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_115_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_115_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_115_0_0);
	public final static Rule JAVA_115 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getPlusPlus(), JAVA_115_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_116_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("--", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_116_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_116_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_116_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_116_0_0);
	public final static Rule JAVA_116 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getMinusMinus(), JAVA_116_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_117_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("~", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_117_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_117_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_117_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_117_0_0);
	public final static Rule JAVA_117 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getComplement(), JAVA_117_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_118_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("!", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_118_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_118_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_118_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_118_0_0);
	public final static Rule JAVA_118 = new Rule(org.emftext.language.java.operators.OperatorsPackage.eINSTANCE.getNegate(), JAVA_118_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_119_0_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("[", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaWhiteSpace JAVA_119_0_0_0_0_0_1 = new org.emftext.language.java.resource.java.grammar.JavaWhiteSpace(0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_119_0_0_0_0_0_2 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("]", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_119_0_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_119_0_0_0_0_0_0, JAVA_119_0_0_0_0_0_1, JAVA_119_0_0_0_0_0_2);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_119_0_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_119_0_0_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaCompound JAVA_119_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaCompound(JAVA_119_0_0_0_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_119_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_119_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_119_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_119_0_0);
	public final static Rule JAVA_119 = new Rule(org.emftext.language.java.arrays.ArraysPackage.eINSTANCE.getArrayDimension(), JAVA_119_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_120_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("null", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_120_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_120_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_120_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_120_0_0);
	public final static Rule JAVA_120 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getNullLiteral(), JAVA_120_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_121_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("public", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_121_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_121_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_121_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_121_0_0);
	public final static Rule JAVA_121 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getPublic(), JAVA_121_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_122_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("abstract", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_122_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_122_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_122_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_122_0_0);
	public final static Rule JAVA_122 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getAbstract(), JAVA_122_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_123_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("protected", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_123_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_123_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_123_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_123_0_0);
	public final static Rule JAVA_123 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getProtected(), JAVA_123_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_124_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("private", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_124_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_124_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_124_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_124_0_0);
	public final static Rule JAVA_124 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getPrivate(), JAVA_124_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_125_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("final", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_125_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_125_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_125_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_125_0_0);
	public final static Rule JAVA_125 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getFinal(), JAVA_125_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_126_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("static", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_126_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_126_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_126_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_126_0_0);
	public final static Rule JAVA_126 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getStatic(), JAVA_126_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_127_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("native", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_127_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_127_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_127_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_127_0_0);
	public final static Rule JAVA_127 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getNative(), JAVA_127_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_128_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("synchronized", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_128_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_128_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_128_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_128_0_0);
	public final static Rule JAVA_128 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getSynchronized(), JAVA_128_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_129_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("transient", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_129_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_129_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_129_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_129_0_0);
	public final static Rule JAVA_129 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getTransient(), JAVA_129_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_130_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("volatile", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_130_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_130_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_130_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_130_0_0);
	public final static Rule JAVA_130 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getVolatile(), JAVA_130_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_131_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("strictfp", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_131_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_131_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_131_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_131_0_0);
	public final static Rule JAVA_131 = new Rule(org.emftext.language.java.modifiers.ModifiersPackage.eINSTANCE.getStrictfp(), JAVA_131_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_132_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("void", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_132_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_132_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_132_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_132_0_0);
	public final static Rule JAVA_132 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getVoid(), JAVA_132_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_133_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("boolean", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_133_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_133_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_133_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_133_0_0);
	public final static Rule JAVA_133 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getBoolean(), JAVA_133_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_134_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("char", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_134_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_134_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_134_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_134_0_0);
	public final static Rule JAVA_134 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getChar(), JAVA_134_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_135_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("byte", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_135_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_135_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_135_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_135_0_0);
	public final static Rule JAVA_135 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getByte(), JAVA_135_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_136_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("short", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_136_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_136_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_136_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_136_0_0);
	public final static Rule JAVA_136 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getShort(), JAVA_136_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_137_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("int", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_137_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_137_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_137_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_137_0_0);
	public final static Rule JAVA_137 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getInt(), JAVA_137_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_138_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("long", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_138_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_138_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_138_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_138_0_0);
	public final static Rule JAVA_138 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getLong(), JAVA_138_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_139_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("float", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_139_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_139_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_139_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_139_0_0);
	public final static Rule JAVA_139 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getFloat(), JAVA_139_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaKeyword JAVA_140_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaKeyword("double", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_140_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_140_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_140_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_140_0_0);
	public final static Rule JAVA_140 = new Rule(org.emftext.language.java.types.TypesPackage.eINSTANCE.getDouble(), JAVA_140_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_141_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getDecimalLongLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.DECIMAL_LONG_LITERAL__DECIMAL_VALUE), "DECIMAL_LONG_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_141_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_141_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_141_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_141_0_0);
	public final static Rule JAVA_141 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getDecimalLongLiteral(), JAVA_141_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_142_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getDecimalFloatLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.DECIMAL_FLOAT_LITERAL__DECIMAL_VALUE), "DECIMAL_FLOAT_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_142_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_142_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_142_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_142_0_0);
	public final static Rule JAVA_142 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getDecimalFloatLiteral(), JAVA_142_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_143_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getDecimalIntegerLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.DECIMAL_INTEGER_LITERAL__DECIMAL_VALUE), "DECIMAL_INTEGER_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_143_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_143_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_143_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_143_0_0);
	public final static Rule JAVA_143 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getDecimalIntegerLiteral(), JAVA_143_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_144_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getDecimalDoubleLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.DECIMAL_DOUBLE_LITERAL__DECIMAL_VALUE), "DECIMAL_DOUBLE_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_144_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_144_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_144_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_144_0_0);
	public final static Rule JAVA_144 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getDecimalDoubleLiteral(), JAVA_144_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_145_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getHexLongLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.HEX_LONG_LITERAL__HEX_VALUE), "HEX_LONG_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_145_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_145_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_145_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_145_0_0);
	public final static Rule JAVA_145 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getHexLongLiteral(), JAVA_145_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_146_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getHexFloatLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.HEX_FLOAT_LITERAL__HEX_VALUE), "HEX_FLOAT_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_146_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_146_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_146_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_146_0_0);
	public final static Rule JAVA_146 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getHexFloatLiteral(), JAVA_146_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_147_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getHexDoubleLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.HEX_DOUBLE_LITERAL__HEX_VALUE), "HEX_DOUBLE_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_147_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_147_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_147_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_147_0_0);
	public final static Rule JAVA_147 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getHexDoubleLiteral(), JAVA_147_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_148_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getHexIntegerLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.HEX_INTEGER_LITERAL__HEX_VALUE), "HEX_INTEGER_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_148_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_148_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_148_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_148_0_0);
	public final static Rule JAVA_148 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getHexIntegerLiteral(), JAVA_148_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_149_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getOctalLongLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.OCTAL_LONG_LITERAL__OCTAL_VALUE), "OCTAL_LONG_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_149_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_149_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_149_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_149_0_0);
	public final static Rule JAVA_149 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getOctalLongLiteral(), JAVA_149_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_150_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getOctalIntegerLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.OCTAL_INTEGER_LITERAL__OCTAL_VALUE), "OCTAL_INTEGER_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_150_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_150_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_150_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_150_0_0);
	public final static Rule JAVA_150 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getOctalIntegerLiteral(), JAVA_150_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_151_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getCharacterLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.CHARACTER_LITERAL__VALUE), "CHARACTER_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_151_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_151_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_151_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_151_0_0);
	public final static Rule JAVA_151 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getCharacterLiteral(), JAVA_151_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
	public final static org.emftext.language.java.resource.java.grammar.JavaPlaceholder JAVA_152_0_0_0 = new org.emftext.language.java.resource.java.grammar.JavaPlaceholder(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getBooleanLiteral().getEStructuralFeature(org.emftext.language.java.literals.LiteralsPackage.BOOLEAN_LITERAL__VALUE), "BOOLEAN_LITERAL", org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, 0);
	public final static org.emftext.language.java.resource.java.grammar.JavaSequence JAVA_152_0_0 = new org.emftext.language.java.resource.java.grammar.JavaSequence(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_152_0_0_0);
	public final static org.emftext.language.java.resource.java.grammar.JavaChoice JAVA_152_0 = new org.emftext.language.java.resource.java.grammar.JavaChoice(org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE, JAVA_152_0_0);
	public final static Rule JAVA_152 = new Rule(org.emftext.language.java.literals.LiteralsPackage.eINSTANCE.getBooleanLiteral(), JAVA_152_0, org.emftext.language.java.resource.java.grammar.JavaCardinality.ONE);
}
